// 设置地图全局距离后调出路线,场外x公里定义（一公里）
GLOBAL.Config.x_distance = 1000;

//====================
//类：创建一个提示框
//====================
var Tips = function(str) {
	this.initialize(str);
};
Tips.prototype = {
	initialize : function(str) {
		this.str = str;
		this.createTip();
	},
	
	createTip : function() {
		var tip_warp = $("#J_AppExitTipWarp");
		var scroll_top = window.pageYOffset|| document.documentElement.scrollTop || document.body.scrollTop;
		if (! tip_warp.length) {
			tip_warp = $("<div></div>");
			tip_warp.attr("id", "J_AppExitTipWarp");
			tip_warp.css({
				"display" : "block",
				"position" : "absolute",
				"text-align" : "center",
				"width" : "100%",
				"z-index" : "99999999",
				"left" : "0px",
				"top" : scroll_top + 250 + "px"
			});
			$("body").append(tip_warp);
		}
		var tip = $("#J_AppExitTip");
		if (! tip.length) {
			tip = $("<div></div>");
			tip.attr("id", "J_AppExitTip");
			tip.css({
				"display" : "block",
				"width" : "160px",
				"height" : "30px",
				"line-height" : "30px",
				"border-width" : "0px",
				"border-radius" : "10px",
				"box-shadow" : "0 0 20px #000",
				"font-size" : "16px",
				"background-color" : "#000",
				"color" : "#FFF",
				"padding" : "3px 5px",
				"margin" : "0 auto"
			});
			tip_warp.append(tip);
		}
		tip.text(this.str);
	}
};

//==================================
//类：创建一个confirm框(css自定义)
//==================================
var Confirms = function(messages, yesCallback, noCallback) {
	this.initialize(messages, yesCallback, noCallback);
};
Confirms.prototype = {
	initialize : function(messages, yesCallback, noCallback) {
		this.messages = messages;
		this.createConfirms();
		this.confirmEvent(yesCallback, noCallback);
	},
	
	createConfirms : function() {
		// 新建时先清空
		$("#J_ConfirmDialog").remove();
		var confirm_warp = $("#J_ConfirmDialog");
		if (! confirm_warp.length) {
			var confirm_html = '<div id="J_ConfirmDialog" class="confirmWrap hide">';
			confirm_html += '<div class="confirmWrap-dialog">';
			confirm_html += '<div class="confirmWrap-dialog-header">';
			confirm_html += '<span class="confirmWrap-dialog-title">提示</span></div>';
			confirm_html += '<div class="confirmWrap-dialog-body">';
			confirm_html += '<span id="J_ConfirmMessage" class="confirmWrap-dialog-message"></span></div>';
			confirm_html += '<div class="confirmWrap-dialog-footer">';
			confirm_html += '<input type="button" class="confirmWrap-btn" id="J_ConfirmSure" value="确认" />';
			confirm_html += '<input type="button" class="confirmWrap-btn confirmWrap-cancelBtn" id="J_ConfirmCancel" value="取消" /></div>';
			confirm_html += '</div></div>';
			$("body").append(confirm_html);
		}
	},
	
	confirmEvent : function(yesCallback, noCallback) {
		if (this.messages) {
			$('#J_ConfirmMessage').html(this.messages);
		}
		// 显示遮罩和对话框
		$('#J_ConfirmDialog').removeClass("hide");
		// 确定按钮
		$('#J_ConfirmSure').click(function() {
			$('#J_ConfirmDialog').addClass("hide");
			yesCallback();
		});
		// 取消按钮
		$('#J_ConfirmCancel').click(function() {
			$('#J_ConfirmDialog').addClass("hide");
			noCallback();
		});
	}
};

//====================
//类：百度地图API相关
//====================
var BaiduMap = function() {};
BaiduMap.prototype = {
	createMap : function() {
		GLOBAL.Config.obj_map; // 定义全局变量
		GLOBAL.Config.obj_marker; // 定义全局变量
		GLOBAL.Config.geo_marker; // 全局位置图标
		
		// 百度地图API功能（地图点击关闭）
		GLOBAL.Config.obj_map = new BMap.Map('J_BaiduMap',{enableMapClick: false});
		GLOBAL.Config.obj_map.centerAndZoom(new BMap.Point(113.158319,23.108258), 19);
		this.mapAddControl(); // 添加地图控键
		this.mapTileLayer(); // 添加自定义图层
		this.mapDistance(); // 获取两点间的距离
		// this.geolocation(); // 进入地图获取当前位置
		
		// watchPosition()是定期轮询设备的位置 https://developer.mozilla.org/zh-CN/docs/Web/API/Geolocation/watchPosition
		if (navigator.geolocation) {
			var watchid, target, options;
			var watchid = navigator.geolocation.watchPosition(success, error, options);
			// navigator.geolocation.clearWatch(watchid); // 停止监视用户位置
			// 调用地理位置参数
			options = {
				enableHighAccuracy: true, //这个布尔值用来表明应用是否使用其最高精度来表示结果。如果值为 true ，同时设备能够提供一个更精确的位置，那么设备就会使用这个位置
				timeout: 5000, // 表明的是设备必须在多长时间（单位毫秒）内返回一个位置
				maximumAge: 0 // 它表明可以返回多长时间（即最长年龄，单位毫秒）内的可获取的缓存位置。如果设置为 0, 说明设备不能使用一个缓存位置，而且必须去获取一个真实的当前位置
			};
			
			// 位置获取成功调用
			function success(position) {
				// do_something(position.coords.latitude, position.coords.longitude);
				// $('#J_H5TestWarp').remove(); // 移除测试图层, 删除图层注销改段代码
				
				var ggPoint = new BMap.Point(position.coords.longitude, position.coords.latitude); // HTML5的经纬度
				var convertor = new BMap.Convertor();
				var pointArr = [];
				pointArr.push(ggPoint);
				convertor.translate(pointArr, 1, 5, translateCallback);
			}
			
			// h5坐标转换百度地图坐标之后的回调函数
			translateCallback = function (data) {
				if (data.status === 0) {
					var lngCurrent = data.points[0].lng;
					var latCurrent = data.points[0].lat;
						
					// 测试图层
					var tip_warp = $("#J_H5TestWarp");
					var scroll_top = window.pageYOffset|| document.documentElement.scrollTop || document.body.scrollTop;
					if (! tip_warp.length) {
						tip_warp = $("<div></div>");
						tip_warp.attr("id", "J_H5TestWarp");
						tip_warp.css({
							"display" : "block",
							"position" : "absolute",
							"text-align" : "center",
							"width" : "100%",
							"z-index" : "99999999",
							"left" : "0px",
							"top" : scroll_top + 250 + "px",
							"background-color" : "#FFF",
							"color" : "000"
						});
						// $("body").append(tip_warp); // 删除图层注销改段代码
						
						$('#J_H5TestWarp').html("h5 lngCurrent == " + lngCurrent + "<br />h5 latCurrent == " + latCurrent);
					}
					
					// 定义当前位置标识图标
					var icon_path = GLOBAL.Config.base + '/skin/m/img/maps/icon/icon_current.png';
					var myIcon = new BMap.Icon(icon_path,new BMap.Size(65,65),{
						anchor: new BMap.Size(33, 33),
						imageSize: new BMap.Size(65, 65) 
					});
					
					// 标识当前地点
					var obj_map = GLOBAL.Config.obj_map;
					var point_cur = new BMap.Point(lngCurrent, latCurrent);
					GLOBAL.Config.obj_map.removeOverlay(GLOBAL.Config.geo_marker); // 移除先前的标柱
					GLOBAL.Config.geo_marker = ''; 
					if (GLOBAL.Config.geo_marker == '') {
						GLOBAL.Config.geo_marker = new BMap.Marker(point_cur, {icon: myIcon});
						obj_map.addOverlay(GLOBAL.Config.geo_marker);
					}
				}
			}
			
			// 位置调用失败
			// 不支持h5调用用百度地图
			function error() {
				// alert("Sorry, no position available.");
				// 每5秒标识当前位置
				var t = setInterval(function() {
					 // 移除先前的标柱
					GLOBAL.Config.obj_map.removeOverlay(GLOBAL.Config.geo_marker);
					GLOBAL.Config.geo_marker = ''; 
					
					// 百度地图获取当前位置
					var circle = new BMap.Geolocation();
				    var options = {};
				    options.enableHighAccuracy = true; //enableHighAccuracy	Boolean	要求浏览器获取最佳结果。
				    options.timeout = 5000; // timeout	Number	超时时间。
				    options.maximumAge = 0; //  maximumAge	Number	允许返回指定时间内的缓存结果。如果此值为0，则浏览器将立即获取新定位结果。
				    circle.getCurrentPosition(locationResult, options); 
				    GLOBAL.Config.obj_map.addOverlay(circle);
				    var tempGeocoder = new BMap.Geocoder();
				    function locationResult(geolocationResult) {
				        var Status = this.getStatus();
				        if (Status == 0) { //检索成功。对应数值"0"。
				        	var lngCurrent = geolocationResult.point.lng;
							var latCurrent = geolocationResult.point.lat;
							
				        	// 定义当前位置标识图标
							var icon_path = GLOBAL.Config.base + '/skin/m/img/maps/icon/icon_current.png';
							var myIcon = new BMap.Icon(icon_path,new BMap.Size(65,65),{
								anchor: new BMap.Size(33, 33),
								imageSize: new BMap.Size(65, 65) 
							});
							
							// 标识当前地点
							var point_cur = new BMap.Point(lngCurrent, latCurrent);
							if (GLOBAL.Config.geo_marker == '') {
								GLOBAL.Config.geo_marker = new BMap.Marker(point_cur, {icon: myIcon});
								GLOBAL.Config.obj_map.addOverlay(GLOBAL.Config.geo_marker);
							}
				        } else {
				            //alert("定位失败错误码" + Status)
				        }
				    }
				}, 5000);
			}
		} else {
			// alert("该浏览器不支持获取地理位置");
		}
	},
	
	mapInit : function(bmapx, bmapy) {
		this.bmapx = bmapx;
		this.bmapy = bmapy;
		
		GLOBAL.Config.obj_map.removeOverlay(GLOBAL.Config.obj_marker); // 移除先前的标柱
		
		// 定义标识图标
		var icon_path = GLOBAL.Config.base + '/skin/m/img/maps/icon/icon_selected.png';
		var myIcon = new BMap.Icon(icon_path,new BMap.Size(30,40),{
			anchor: new BMap.Size(18, 38),
			imageSize: new BMap.Size(28, 41) 
		});
		
		// 标识当前地点
		var point = new BMap.Point(this.bmapx, this.bmapy);
		GLOBAL.Config.obj_marker = new BMap.Marker(point, {icon: myIcon});
		
		if (this.bmapx != undefined) {
			GLOBAL.Config.obj_map.addOverlay(GLOBAL.Config.obj_marker);
		}
		
		// 定义一个中心点坐标
		if (this.bmapx != undefined) {
			GLOBAL.Config.obj_map.centerAndZoom(new BMap.Point(this.bmapx, this.bmapy), 19);
		}
		
		this.mapAddWay(); // 添加路线
	},
	
	mapSetIcon : function(array_point) {
		this.array_point = array_point;
		if (this.array_point != undefined) {
			var obj_map = GLOBAL.Config.obj_map;
			var point_length = array_point.length;
			$.each(this.array_point, function(key, value) {
				// 触屏版设定加载15个
				if (key < 15) {
					var mapx = value[0];
					var mapy = value[1];
					
					var point = new BMap.Point(mapx, mapy);
					
					if (key == 0) {
						// 定义第一个中心点坐标
						obj_map.centerAndZoom(new BMap.Point(mapx, mapy), 19);
					}
					
					// 定义标识图标
					var icon_path;
					if (point_length == 1) {
						icon_path = GLOBAL.Config.base + '/skin/m/img/maps/icon/icon_selected.png';
					} else {
						icon_path = GLOBAL.Config.base + '/skin/m/img/maps/icon/icon_bluecoordinate.png';
					}
					
					var myIcon = new BMap.Icon(icon_path,new BMap.Size(30,40),{
						anchor: new BMap.Size(18, 38),
						imageSize: new BMap.Size(28, 41) 
				    });
					var marker = new BMap.Marker(point, {icon: myIcon});
					obj_map.addOverlay(marker);
	
					var label;
					if (key >= 9) {
						label = new BMap.Label(key + 1, {offset:new BMap.Size(5,8)});
					} else {
						label = new BMap.Label(key + 1, {offset:new BMap.Size(9,8)});
					}
					label.setStyle({
						background:'none',color:'#fff',border:'none'
					});
					marker.setLabel(label);
				}
			});
		}
	},
	
	mapAddWay : function() {
		var obj_this = this;
		var obj_map = GLOBAL.Config.obj_map;
		var obj_mark = GLOBAL.Config.obj_marker;
		
		// 点击选取起点标注
		var point;
		var marke;
		$('.j_MapCompanyList').each(function() {
			var list_this = $(this);
			
			// 终点坐标
			var list_bmapx = list_this.attr("data-bmapx");
			var list_bmapy = list_this.attr("data-bmapy");
			// 店铺信息
			var title = list_this.find(".j_CompanyName").text();
			var content = list_this.find(".j_CompanyAddress").text();
			
			if ($("#J_MapCompanyBox").attr("data-iswechat") != "true") {
				$(this).find(".j_MapCompanyLocation").click(function() {
					// 判断当前位置距离店铺长度
					var distance = list_this.attr("data-distance");
					// 大于x公里后执行调用外部驾车导航
					if (distance > GLOBAL.Config.x_distance) {
						var location_url = "https://api.map.baidu.com/marker?location=" + list_bmapy + "," + list_bmapx;
						location_url += "&title=" + title + "&content=" + content + "&output=html";
						if ($("#J_BaiduMap").attr("data-redirect-pre")) {
							var url = location_url;
							var ref = window.open(url, '_blank', 'location=yes,zoom=no');
							ref.addEventListener('loaderror', function() {
								navigator.notification.alert('载入错误，请检查网络连接！', function(){}, '错误', '确定');
								ref.close();
							});
						} else {
							window.location = location_url;
						}
					} else { // 直接显示路线
						obj_map.clearOverlays(); // 移除先前的标柱
						// 隐藏出现相关列表
						$("#J_MapCompanyBox").css("display", "none");
						$("#J_MapCompanySearch").css("display", "none");
						$("#J_MapWaySearch").css("display", "block");
						$("#J_MapWayCompanyName").text(title);
						
						// 全局记录位置
						$("#J_MapCompanyBox").attr("data-mapx", list_bmapx);
						$("#J_MapCompanyBox").attr("data-mapy", list_bmapy);
						$("#J_MapCompanyBox").attr("data-name", title);
						$("#J_MapCompanyBox").attr("data-address", content);
						
						// 点击路线直接显示当前位置到店铺路线(***front版本在外面***)
						var global_mapx = $("#J_MapCompanyBox").attr("data-mapx");
						var global_mapy = $("#J_MapCompanyBox").attr("data-mapy");
						
						// 解决company有时后不出现路线
						var point = '';
						var point_shop = new BMap.Point(list_bmapx, list_bmapy);
						obj_this.mapAddWayListener(point, point_shop, true);
					}
				});
			}
		});
		
		// 点击我的位置选图
		$("#J_MapWayCur").click(function() {
			// 隐藏搜索框
			$("#J_MapWaySearch").css("display", "none");
			// 显示选点框
			$("#J_MapWayPic").css("display", "block");
			obj_map.clearOverlays(); // 移除先前的标柱
			// 全局记录开始选图
			$("#J_MapCompanyBox").attr("data-ispick", "true");
		});
		
		// 监听选取坐标
		obj_map.addEventListener("touchstart", function(e) {
			// 获取终点坐标
			var mapx = $("#J_MapCompanyBox").attr("data-mapx");
			var mapy = $("#J_MapCompanyBox").attr("data-mapy");
			var pickpoint = $("#J_MapCompanyBox").attr("data-ispick");
			
			if (mapx != undefined && mapy != undefined && pickpoint != undefined) {
				var point_shop = new BMap.Point(mapx, mapy);
				// 点击获取经度维度
				var longitude = e.point.lng; // 经度
				var latitude = e.point.lat; // 纬度
				point = new BMap.Point(longitude,latitude);
				
				var icon_path = GLOBAL.Config.base + '/skin/m/img/maps/icon/icon_selected.png';
				var myIcon = new BMap.Icon(icon_path,new BMap.Size(30,40),{
					anchor: new BMap.Size(18, 38),
					imageSize: new BMap.Size(28, 41) 
				});
				
				marke = new BMap.Marker(point, {icon: myIcon});
				obj_map.clearOverlays(); // 移除先前的标柱
				obj_map.addOverlay(marke);
				
				// 出现地点确认
				$("#J_MapWayAddress").css("display", "block");
				var geoc = new BMap.Geocoder();
				var pt = e.point;
				geoc.getLocation(pt, function(rs) {
					var addComp = rs.addressComponents;
					// alert(addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber);
					var address_text = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
					$(".j_MapWayAddress_text").each(function() {
						$(this).text(address_text);
					});
				});
				
				// 点击确认选点出现路线
				$("#J_MapWaySure").click(function() {
					obj_this.mapAddWayListener(point, point_shop, false);
					// 隐藏显示选项框
					$("#J_MapWayAddress").css("display", "none");
					$("#J_MapWayPic").css("display", "none");
					$("#J_MapWaySearch").css("display", "block");
					// 禁止选点
					$("#J_MapCompanyBox").removeAttr("data-ispick");
				});
			}
		});
		
		// 选图后返回执行当前位置导航
		$("#J_MapWayBack").click(function() {
			var global_mapx = $("#J_MapCompanyBox").attr("data-mapx");
			var global_mapy = $("#J_MapCompanyBox").attr("data-mapy");
			var point = '';
			var point_shop = new BMap.Point(global_mapx, global_mapy);
			obj_this.mapAddWayListener(point, point_shop, true);
			// 隐藏显示选项框
			$("#J_MapWayAddress").css("display", "none");
			$("#J_MapWayPic").css("display", "none");
			$("#J_MapWaySearch").css("display", "block");
			// 禁止选点
			$("#J_MapCompanyBox").removeAttr("data-ispick");
		});
		
		// 搜索起点
		$(".j_MapSearchBtn").click(function() {
			var text = $(this).parents("#J_MapWaySearch").find(".j_MapSearchInput").val();
			var local = new BMap.LocalSearch(obj_map, {
				renderOptions:{map: obj_map}
			});
			local.search(text);
		});
		
		// 删除选图提示
		$("#J_MapWayTipClose").click(function() {
			$(this).parent().css("display", "none");
		});
		
		// 退出路线规划
		$("#J_MapSearchBack").click(function() {
			//window.location.reload();
			obj_map.clearOverlays(); // 移除先前的标柱
			
			// 隐藏出现相关列表
			$("#J_MapCompanyBox").css("display", "block");
			$("#J_MapCompanySearch").css("display", "table");
			$("#J_MapWaySearch").css("display", "none");
			
			// 清空全局记录
			$("#J_MapCompanyBox").removeAttr("data-mapx");
			$("#J_MapCompanyBox").removeAttr("data-mapy");
			$("#J_MapCompanyBox").removeAttr("data-name");
			$("#J_MapCompanyBox").removeAttr("data-address");
			
			// 返回地图初始状态
			var bmapx = $("#J_MapCompanyBox").find(".cur").attr("data-bmapx");
			var bmapy = $("#J_MapCompanyBox").find(".cur").attr("data-bmapy");
			obj_this.mapInit(bmapx, bmapy);
		});
	},
	
	mapAddWayListener : function(point, point_shop, isgeolocation) {
		var obj_map = GLOBAL.Config.obj_map;
		var geolocation = new BMap.Geolocation();
		geolocation.getCurrentPosition(function(r) {
			if (this.getStatus() == BMAP_STATUS_SUCCESS) {
				obj_map.clearOverlays(); // 移除先前的标柱
				// 隐藏提示
				//$("#J_MapWayTip").css("display", "none");
				
				// 判断是否当前位置开始
				if (isgeolocation) {
					var lngCurrent = r.point.lng;
					var latCurrent = r.point.lat;
					point = new BMap.Point(lngCurrent,latCurrent);
				}
				
				// 路线显示
				var distance = (obj_map.getDistance(point ,point_shop)).toFixed(2); // 获取两点距离,保留小数点后两位
				if (parseFloat(distance) >= GLOBAL.Config.x_distance) {
					// 驾车
					$("#J_MapWapOpen").css("display", "block");
					var driving = new BMap.DrivingRoute(obj_map, { 
						renderOptions: { 
							map: obj_map, 
							autoViewport: true
						}
					});
					driving.search(point, point_shop);
				} else {
					// 步行
					$("#J_MapWapOpen").css("display", "none");
					var walking = new BMap.WalkingRoute(obj_map, { 
						renderOptions: { 
							map: obj_map, 
							autoViewport: false 
						}
					});
					walking.search(point, point_shop);
					
					// 800毫秒后平移到起点
					setTimeout(function() {
						GLOBAL.Config.obj_map.panTo(point);
					}, 800);
				}
			} else {
				//关于状态码
				//BMAP_STATUS_SUCCESS	检索成功。对应数值"0"。
				//BMAP_STATUS_CITY_LIST	城市列表。对应数值"1"。
				//BMAP_STATUS_UNKNOWN_LOCATION	位置结果未知。对应数值"2"。
				//BMAP_STATUS_UNKNOWN_ROUTE	导航结果未知。对应数值"3"。
				//BMAP_STATUS_INVALID_KEY	非法密钥。对应数值"4"。
				//BMAP_STATUS_INVALID_REQUEST	非法请求。对应数值"5"。
				//BMAP_STATUS_PERMISSION_DENIED	没有权限。对应数值"6"。(自 1.1 新增)
				//BMAP_STATUS_SERVICE_UNAVAILABLE	服务不可用。对应数值"7"。(自 1.1 新增)
				//BMAP_STATUS_TIMEOUT	超时。对应数值"8"。(自 1.1 新增)
				
				alert('failed'+this.getStatus());
			}
		}, {enableHighAccuracy: true}, {maximumAge: 0}); // maximumAge: 0如果此值为0，则浏览器将立即获取新定位结果
	},
	
	mapAddControl : function() {
		// 添加百度地图控件
		//GLOBAL.Config.obj_map.addControl(new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_RIGHT, type: BMAP_NAVIGATION_CONTROL_SMALL}));

		// 添加定位控件
		var geolocationControl = new BMap.GeolocationControl({
			anchor:BMAP_ANCHOR_TOP_RIGHT, 
			offset:new BMap.Size(12,200),
		});
		geolocationControl.addEventListener("locationSuccess", function(e) {
			// 定位成功事件
			// GLOBAL.Config.obj_map.removeOverlay(GLOBAL.Config.geo_marker); // 移除先前的标柱
			var address = '';
			address += e.addressComponent.province;
			address += e.addressComponent.city;
			address += e.addressComponent.district;
			address += e.addressComponent.street;
			address += e.addressComponent.streetNumber;
			//alert("当前定位地址为：" + address);
		});
		geolocationControl.addEventListener("locationError",function(e) {
			// 定位失败事件
			//alert(e.message);
		});
		GLOBAL.Config.obj_map.addControl(geolocationControl);
		
		GLOBAL.Config.obj_map.setCurrentCity("佛山"); // 设置地图显示的城市
		
		// 启用滚轮放大缩小
		GLOBAL.Config.obj_map.enableScrollWheelZoom();
		
		// 版权说明
		var copyCtrl = new BMap.CopyrightControl({anchor: BMAP_ANCHOR_BOTTOM_RIGHT});
		copyCtrl.addCopyright({id: 1, content: "版权说明：广东南国小商品城"});
		GLOBAL.Config.obj_map.addControl(copyCtrl);
	},
	
	mapTileLayer : function() {
		// 新建图层（图片由软件生成，根据zoom数值来更换图片显示
		var tileLayer;
		
		// 移除旧的图层
		//GLOBAL.Config.obj_map.removeTileLayer(tileLayer);	

		// 重新新建图层
		tileLayer = new BMap.TileLayer({isTransparentPng: true});
		
		// 根据当前坐标，选取合适的瓦片图
		tileLayer.getTilesUrl = function(tileCoord, zoom) {
			var x = tileCoord.x;
			var y = tileCoord.y;
			return GLOBAL.Config.base + '/skin/m/img/maps/' + zoom + '/tile' + x + '_' + y + '.png';
		};
		
		// 添加图层
		GLOBAL.Config.obj_map.addTileLayer(tileLayer);
	},
	
	mapDistance : function() {
		var obj_map = GLOBAL.Config.obj_map;
		// 根据浏览器获取当前位置坐标计算目标点距离
		$('.j_MapCompanyList').each(function() {
			var obj_this = $(this);
			var list_bmapx = $(this).attr("data-bmapx");
			var list_bmapy = $(this).attr("data-bmapy");
			
			var geolocation = new BMap.Geolocation();
			geolocation.getCurrentPosition(function(r) {
				if (this.getStatus() == BMAP_STATUS_SUCCESS) {
					var lngCurrent = r.point.lng;
					var latCurrent = r.point.lat;
					var point_cur = new BMap.Point(lngCurrent,latCurrent);
					var point_shop = new BMap.Point(list_bmapx,list_bmapy);
					var distance = (obj_map.getDistance(point_cur,point_shop)).toFixed(2); // 获取两点距离,保留小数点后两位
					
					// 记录每个店铺距离
					obj_this.attr("data-distance", distance);
					var text_distance;
					if (parseFloat(distance) >= 1000) {
						distance = (distance / 1000).toFixed(2);
						text_distance = distance + "km";
					} else {
						text_distance = distance + "m";
					}
					
					// 显示距离
					obj_this.find(".j_MapDistance").text(text_distance);
					// 显示路线列表
					$("#J_MapCompanyBox").css("display", "block");
				} else {
					// 获取不了当前位置也要 显示路线列表
					$("#J_MapCompanyBox").css("display", "block");
					//alert('failed'+this.getStatus());
				}
			}, {enableHighAccuracy: true}, {maximumAge: 0}); // maximumAge: 0如果此值为0，则浏览器将立即获取新定位结果
		});
	},
	
	geolocation : function() {
		// 获取当前位置
		var obj_map = GLOBAL.Config.obj_map;
		GLOBAL.Config.obj_map.removeOverlay(GLOBAL.Config.geo_marker); // 移除先前的标柱
		var geolocation = new BMap.Geolocation();
		geolocation.getCurrentPosition(function(r) {
			if (this.getStatus() == BMAP_STATUS_SUCCESS) {
				var lngCurrent = r.point.lng;
				var latCurrent = r.point.lat;
				
				// 定义当前位置标识图标
				var icon_path = GLOBAL.Config.base + '/skin/m/img/maps/icon/icon_current.png';
				var myIcon = new BMap.Icon(icon_path,new BMap.Size(65,65),{
					anchor: new BMap.Size(33, 33),
					imageSize: new BMap.Size(65, 65) 
				});
				
				// 标识当前地点
				var point_cur = new BMap.Point(lngCurrent,latCurrent);
				GLOBAL.Config.geo_marker = new BMap.Marker(point_cur, {icon: myIcon});
				obj_map.addOverlay(GLOBAL.Config.geo_marker);
				GLOBAL.Config.geo_marker.setAnimation(BMAP_ANIMATION_BOUNCE); //跳动的动画
			} else {
				//alert('failed'+this.getStatus());
			}
		}, {enableHighAccuracy: true}, {maximumAge: 0}); // maximumAge: 0如果此值为0，则浏览器将立即获取新定位结果
	}
};


//====================
//类：全局调用(加入购物车相关事件)
//====================
var GlobalBind = function() {
	this.initialize();
};
GlobalBind.prototype = {
	initialize : function() {
		this.getData();
	},
	getData : function() {
		//====================
		// 产品属性操作
		//====================
		 $(".j_ProductAttrAssociate").each(function() {
			var self = $(this);//当前选择的对象
			self.unbind("click").click(function() {
				var json = self.parents(".cartAttribute-content").find(".j_CartAttrAssociate").data("json");//json数组
				var attr_len = 0;//属性数量
				for (var i in json[0]) {
					if (i != "path") {
						attr_len++;
					}
				}
				var attribute = self.data("attribute");//当前对象的属性
				var value = self.data("value");//当前对象的属性值
				self.parents(".j_CartAttrAssociate").find(".j_ProductAttrAssociate[data-attribute='" + attribute + "']").removeClass("cur");
				self.addClass("cur");
				self.parents(".j_CartAttrAssociate").find(".j_ProductAttrTips").css("display","block");

		
				var cur_obj = {};//当前已选择的属性
				self.parents(".j_CartAttrAssociate").find(".j_ProductAttrAssociate.cur").each(function () {
					var cur_attribute = $(this).data("attribute");
					var cur_value = $(this).data("value");
					cur_obj[cur_attribute] = cur_value;
				
					$(this).parents(".j_ProductAttrList").find(".j_ProductAttrTips").css("display","none");
				});
				var cur_len = self.parent("li").find(".j_ProductAttrAssociate.cur").length;//当前已选择的属性数量

				self.parents(".j_CartAttrAssociate").find(".j_ProductAttrAssociate").addClass("disable");

				var has_match = false;//是否有匹配已选属性的选项
				var full_match = false;//是否匹配所有属性
				for (var i = 0; i < json.length; i++) {
					var match_count = 0;//匹配已选属性的数量
					for (var j in json[i]) {
						if (j != "path" && cur_obj[j] == json[i][j]) {
							match_count++;
						}
					}
					if (match_count == cur_len) {
						has_match = true;
						for (var k in json[i]) {
							self.parent("li").find(".j_ProductAttrAssociate[data-attribute='" + k + "'][data-value='" + json[i][k] + "']").removeClass("disable");
						}
					}
					if (match_count == attr_len) {
						full_match = true;
						var path = json[i]["path"];//				console.log(path);

						//$(location).attr("href",path);
						attr_change_product(self, path);
						for (var k in json[i]) {
							self.parent("li").find(".j_ProductAttrAssociate[data-attribute='" + k + "'][data-value='" + json[i][k] + "']").removeClass("disable");
						}
					}
				}
				if (!has_match || cur_len == 1) {
					self.parents(".j_CartAttrAssociate").find(".j_ProductAttrAssociate.cur").each(function () {
						$(this).removeClass("cur");
					});
					$(self).addClass("cur");
					self.parents(".j_ProductAttrList").find(".j_ProductAttrTips").css("display","none");
					self.parents(".j_ProductAttrList").siblings().find(".j_ProductAttrTips").css("display","block");
					cur_obj = {};
					cur_obj[attribute] = value;
					cur_len = 1;
					for (var i = 0; i < json.length; i++) {
						if (json[i][attribute] == value) {
							for (var k in json[i]) {
								self.parents(".j_CartAttrAssociate").find(".j_ProductAttrAssociate[data-attribute='" + k + "'][data-value='" + json[i][k] + "']").removeClass("disable");
							}
						} else {
							for (var k in json[i]) {
								if (k == attribute) {
									self.parents(".j_CartAttrAssociate").find(".j_ProductAttrAssociate[data-attribute='" + k + "'][data-value='" + json[i][k] + "']").removeClass("disable");
								}
							}
						}
					}
				}
			});
		});
		
		// 切换属性时通过ajax获取产品更改
		function attr_change_product(obj, attr_path) {
			var is_app = obj.attr("data-redirect-pre");
			var pr_aid = obj.attr("data-aid");
			var url = GLOBAL.Config.base + "/product/proajax/?id=" + pr_aid;
			
			// ajax获取产品信息,改变当前产品信息
			$.ajax({
				url : url,
				type : "post",
				dataType : "json",
				headers: {'X-Requested-With': 'XMLHttpRequest'},
				success: function(product) {
					// 改变产品图
					var pro_img;
					if (is_app) {
						pro_img = "./df/skin/m/img/nopic_t.gif";
					} else {
						pro_img = "/skin/m/img/nopic_t.gif";
					}
					if (product.picname[0][1]) {
						pro_img = GLOBAL.Config.base + product.picname[0][1];
					}
					obj.parents(".j_CartAttBox").find(".j_CartAttImg").attr("src", pro_img);
					
					// 改变货号
					obj.parents(".j_CartAttBox").find(".j_CartAttCode").text(product.code);
					
					// 改变价格
					var price_html;
					if (product.prices.currency == 'CNY') product.prices.currency = '￥ ';
					if (product.prices.type == "Negotiable") {
						price_html = '<span class="cartAttribute-minPrice">面议</span>';
					} else {
						price_html = '<span class="cartAttribute-minPrice">' +
								'<span class="cartAttribute-sign">' +
								product.prices.currency +
								'</span><span class="j_CartAttrPrice">';
						if (product.prices.checkout.type == "Batch") {
							price_html += product.prices.min + '</span></span>';
						} else {
							price_html += product.prices.max + '</span></span>';
						}
					}
					obj.parents(".j_CartAttBox").find(".j_CartAttPrice").html(price_html);
					
					// 改变分级价格
					var each_num;
					var tier_content_html;
					if (product.prices.checkout.type == "Batch") {
						tier_content_html = '<div class="cartAttribute-box j_CartBatchBox">' +
								'<div class="proTable proTitle">' +
								'<div class="proTable-cell batch">包装数量</div>' +
								'<div class="proTable-cell batch">价格</div>' +
								'<div class="proTable-cell batch">数量</div>' +
								'</div>';
						each_num = "1"; // 记录循环的次数

						$.each(product.prices.checkout.range, function(key, tier) {
							var num;
							if (each_num == '1') {
								num = '1';
							} else {
								num = '0';
							}
							var tier_each_html = '<div class="proTable">' +
										'<span class="proTable-cell number batch">' +
										'[1 x ' + key + ']' +
										'</span><span class="proTable-cell price batch">' +
										'<span class="proTable-currencyPrice">' + product.prices.currency + '</span>' +
										'<span class="j_TierPrice">' + tier.price + '</span>' +
										'<span class="unitPrice"> /' + tier.unit + '</span></span>' +
										'<span class="proTable-cell addCartTextBox batch j_Spec"' +
										'data-spec="' + key +' " data-price=" ' + tier.price + '"' +
										'data-aid="'+ product.aid +'">';
							if (tier.is_enable == '0') {
								tier_each_html += '<span class="j_IsEnable" style="display:none"></span>';
							} else {
								tier_each_html += '<a href="javascript:void(0);" class="j_AddCartBtnReduce addCartReduce" ';
								tier_each_html += 'data-price-batch="true"></a> <input type="text" class="j_AddCartText text"';
								tier_each_html += ' value="' + num + '" maxlength="6" size="4" data-price-batch="true" />';
								tier_each_html += '<a href="javascript:void(0);" class="j_AddCartBtnAdd addCartAdd" data-price-batch="true"></a>';
							}
							tier_each_html += '</span></div>';
							
							tier_content_html += tier_each_html;
							each_num ++;
						});
						
						tier_content_html += '<input id="J_AddCartQty-' + product.aid + '" type="hidden" name="qty[' + product.aid + ']"';
						tier_content_html += ' value="1" /></div>';
					} else if (product.prices.checkout.type == "Single") {
						each_num = "1"; // 记录循环的次数
						
						// 获取对象的长度
						var tier_length = 0;
						$.each(product.prices.checkout.range, function(key, tier) {
							tier_length ++;
						});
						
						tier_content_html = '<div class="cartAttribute-box"><div class="proTable proTitle">' +
								'<div class="proTable-cell">起批量</div>' +
								'<div class="proTable-cell">价格</div></div>';
						$.each(product.prices.checkout.range, function(key, tier) {
							var tier_each_html = '<div class="proTable"><span class="j_Tier proTable-cell number">';
							// 判断是否为最后一个循环
							if (each_num == tier_length) {
								tier_each_html += '&ge; ' + key;
							} else {
								tier_each_html += key;
							}
							tier_each_html += '</span><span class="proTable-cell"><span class="price j_TierPrice">';
							tier_each_html += '<span class="proTable-currencyPrice">' + product.prices.currency + '</span>';
							tier_each_html += '<span>' + tier.price + '</span></span>';
							if (tier.unit) {
								tier_each_html += '<span class="proTable-unitPrice">' + tier.unit + '</span>';
							}
							tier_each_html += '</span></div>';
							
							tier_content_html += tier_each_html;
							each_num ++;
						});
						tier_content_html += '</div>';
					}
					obj.parents(".j_CartAttBox").find(".j_CartAttrTier").html(tier_content_html);
					
					
					// 改变购物车数量
					if (product.prices.checkout.type == "Single" || product.prices.type == "Negotiable") {
						if (product.prices.min_qty == null) product.prices.min_qty = '1';
						var pro_number_html = '<div class="cartAttribute-numberBox clearfix">' +
								'<div class="cartAttribute-number">数量</div>' +
								'<div class="cartAttribute-numberChange">' +
								'<span class="addCartTextBox">' +
								'<a href="javascript:void(0);" class="j_AddCartBtnReduce addCartReduce" data-price-change="true"></a>' +
								'<input id="J_AddCartQty-' + product.aid +'" type="text" class="j_AddCartText text"' +
								'name="qty[' + product.aid +']"' +
								'data-minqty="' + product.prices.min_qty + '"' +
								'value="' + product.prices.min_qty + '"' +
								'maxlength="6" size="4" data-price-change="true" />' +
								'<a href="javascript:void(0);" class="j_AddCartBtnAdd addCartAdd" data-price-change="true"></a>' +
								'</span></div></div>';
						
						obj.parents(".j_CartAttBox").find(".j_CartAttrNumber").html(pro_number_html);
					} else {
						obj.parents(".j_CartAttBox").find(".j_CartAttrNumber").html("");
					}
					
					// 改变按钮状态
					var pro_btn_html;
					if (product.is_soldout == 'No') {
						pro_btn_html = '<div class="cartAttribute-btn j_AddCartBtn" data-login-redirect="true" ' +
								'data-aid="' + product.aid + '">确定</div>';
					} else {
						pro_btn_html = '<div class="cartAttribute-btn no">缺货</div>';
					}
					
					obj.parents(".j_CartAttBox").find(".j_CartAttrBtn").html(pro_btn_html);
					
					// 产品列表点击黑色屏幕不跳转，产品详情页如果不是当前产品点击跳转
					var old_aid = $(".j_AddFavor").attr("data-aid"); // 记录上一个aid 
					if (($("#J_CartAttBox").length > 0) && (old_aid != product.aid)) {
						var url;
						if (is_app) {
							url = "./template.html?controller=product&action=index&id=" + obj.attr("data-aid");
						} else {
							url = GLOBAL.Config.base + attr_path;
						}
						$("#J_ThickDiv").click(function() {
							window.location = url;
						});
						
						$(".j_CartAttrClose").click(function() {
							window.location = url;
						});
						
						// 点击购物车跳转到该产品详情
						$(".j_AddCartBtn").attr("data-redirect", url);
					} else {
						// 移动除去前一个绑定的跳转事件
						$("#J_ThickDiv").unbind();
						$(".j_CartAttrClose").unbind();
					}
					
					// 改变属性列表
					if (product.attribute.associate) {
						var associate_html = '<div class="cartAttribute-box">';
						$.each(product.attribute.associate, function(key, list) {
							var associate_each_html = '<div class="j_ProductAttrList cartAttribute-item">' +
													'<div class="cartAttribute-itemTitle">' + list.name +
													'<span class="j_ProductAttrTips">请选择' + list.name + '</span></div>' +
													'<ul class="clearfix">';
							$.each(list.values, function(key, value) {
								var cur;
								if (value.is_selected == true) {
									cur = " cur";
								} else {
									cur = "";
								}
								
								var disable;
								if (value.is_disable == true) {
									disable = " disable";
								} else {
									disable = "";
								}
								var list_each_html = '<li class="j_ProductAttrAssociate' + cur + disable + '"' +
										'data-attribute="' + list.name + '"' +
										'data-value="' + value.name + '"' +
										'data-aid="' + value.pr_aid + '"' +
										'data-path="' + value.path + '">' +
										value.name +
										'</li>';
								associate_each_html += list_each_html;
							});
							associate_each_html += '</ul></div>';
							associate_html += associate_each_html;
						});
						associate_html += '</div>';
						obj.parents(".j_CartAttBox").find(".j_CartAttrAssociate").html(associate_html);
					} else {
						obj.parents(".j_CartAttBox").find(".j_CartAttrAssociate").html("");
					}
					
					// 加入购物车事件触发
					new GlobalBind();
				},
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					alert("网络加载失败！");
					window.location.reload();
					// alert(XMLHttpRequest.status);
					// alert(XMLHttpRequest.readyState);
					// alert(textStatus);
				}
			});
		}
		
		//====================
		//分级价格批量销售
		//====================
		
		// 判断批量销售的默认数量
		if ($(".j_IsEnable").length > 0) {
			$(".j_IsEnable").each(function() {
				$(this).parent().parent().parent().find(".j_AddCartText").first().val("1");
			});
		}
		
		// 默认总数量
		$(".j_CartBatchBox").each(function() {
			var obj_this = $(this);
			obj_this.find(".j_AddCartText").each(function() {
				var is_num = $(this).val();
				if (is_num == "1") {
					var spec = $(this).parent().attr("data-spec");
					var aid = $(this).parent().attr("data-aid");
					$('#J_AddCartQty-' + aid).val(spec);
				}
			});
		});
		
		// 购物车默认数量
		$(".j_BatchCartBox").each(function() {
			// 将总数量放到第一input，然后分配下去
			var obj_this = $(this);
			var key = $(this).attr("data-key");
			var total_num = $("#J_BatchNum-" + key).val();
			// 包装数量数组
			var array_spec = [];
			$(this).find(".j_Spec").each(function() {
				var batch_spec = $(this).attr("data-spec");
				array_spec.push(batch_spec);
			});
			// 弹出最后一个规格数
			var pop_spec = array_spec.pop();
			// 购物总数
			var cart_num = parseInt(total_num);
			check_tier(pop_spec, cart_num);
			
			function check_tier(pop_spec, cart_num) {
				obj_this.find(".j_AddCartText").each(function() {
					// 当前包装量
					var cur_spec = $(this).parent().attr("data-spec");
					if (pop_spec == cur_spec) {
						// 舍去法取整
						var cur_num = Math.floor(parseInt(cart_num) / parseInt(cur_spec));
						// 余下总数
						cart_num = parseInt(cart_num) % parseInt(cur_spec);
						$(this).val(cur_num);
						// 判断数组是否空
						if (array_spec.length) {
							pop_spec = array_spec.pop();
							check_tier(pop_spec, cart_num);
						}
					}
				});
			}
		});
		
		//====================
		//grid 列表样式
		//====================
		if ($(".j_GridNoPic").length > 0) {
			$("#J_DroadLoadBox").find(".j_GridNoPic").each(function() {
				var is_pic = $(this).next();
				if (is_pic.hasClass("j_GridPicList")) {
					$(this).find(".nopicList-box").css("margin-bottom", "11px");
				}
			});
		}
		
		// 分级价格判断
		$(".j_Tier").each(function() {
			var number = $(this).text();
			var number_next = $(this).parent().next().children(".j_Tier").text();
			
			if (isNaN(number_next)) {
				number_next = number_next.replace("≥", "");
			}
			
			var isnumber = number.match(/\d+/g);
			var isgt = number.indexOf('≥') != -1;
			var islink = number.indexOf('-') != -1;
			
			// 判断字符串中是否含有数字且不含"≥"
			if (isnumber && ! isgt && !islink) {
				number_next = parseInt(number_next) - 1;
				if (number_next == number) {
					$(this).text(number);
				} else {
					$(this).text(number + "- " + number_next);
				}
			}
		});
		
		// 产品详情页加入购物车
		$(".j_CartAttrProduct").each(function() {
			$(this).click(function() {
				$("#J_ThickDiv").show();
				$("#J_CartAttBox").show();
			});
		});
		
		// 列表加入购物车
		$(".j_CartAttr").each(function() {
			$(this).click(function() {
				$("#J_ThickDiv").show();
				$(this).parent().find(".j_CartAttBox").show();
			});
		});
		
		// 关闭购物车属性弹出框
		$(".j_CartAttrClose").each(function() {
			$(this).click(function() {
				$("#J_ThickDiv").hide();
				$(".j_CartAttBox").each(function() {
					$(this).hide();
				});
			});
		});
		$("#J_ThickDiv").click(function() {
			$("#J_ThickDiv").hide();
			$(".j_CartAttBox").each(function() {
				$(this).hide();
			});
		});
		
		$(".j_AddCartBtn").each(function() {
			$(this).click(function() {
				$("#J_ThickDiv").hide();
				$(".j_CartAttBox").each(function() {
					$(this).hide();
				});
			});
		});
		
		// 手动输入数字时触发input数值变化
		$(".j_AddCartText").each(function() {
			$(this).bind('input propertychange', function() {
				var obj_this = $(this);
				var add_cart_text = $(this);
				change_tier_price(obj_this, add_cart_text);
				
				if (obj_this.parent().attr("data-is-cart")) {
					var key = obj_this.parents(".j_BatchCartBox").attr("data-key");
					var batch_text = $("#J_BatchNum-" + key);
					return update_qty(batch_text, '1', '1', obj_this);
				}
			});
		});
		
		// "加入购物车"按钮
		$(".j_AddCartBtn").each(function() {
			$(this).click(function() {
				var aid = $(this).attr("data-aid");
				var qty = $('#J_AddCartQty-' + aid).val();
				if ($(this).attr("data-qty")) {
					qty = $(this).attr("data-qty");
				} 
				var lancode = GLOBAL.Config.lancode;
		
				var url_add = GLOBAL.Config.base + "/cart/add/";
				var url_cart = GLOBAL.Config.base + "/cart/cartajax/";
				
				var obj_cart = new Cart();
				obj_cart.add(url_add, url_cart, aid, qty, lancode);
			});
		});
		
		// 数量文本框只允许录入数字
		$(".j_AddCartText").each(function() {
			$(this).keydown(function(e) {
				if ((e.keyCode >= 48 && e.keyCode <= 57) || (e.keyCode >= 96 && e.keyCode <= 105) || 
						(e.keyCode >= 37 && e.keyCode <= 40) || e.keyCode == 8 || e.keyCode == 46 || e.keyCode == 13 ||
						e.keyCode == 17 || e.keyCode == 67 || e.keyCode == 86) {
					return true;
				} else {
					return false;
				}
			});
		});
		
		// 检查数量文本框最小订购量（cart/index页）
		$(".j_AddCartTextCheckedMinQty").each(function() {
			var min_qty = $(this).attr('data-minqty');
			if (min_qty) {
				var old_qty = $(this).val();
				$(this).blur(function() {
					return update_qty($(this), min_qty, old_qty, $(this));
				});
			}
		});
		
		// 加减数量文本框
		$(".j_AddCartBtnAdd").each(function() {
			$(this).unbind("click").click(function() {
				var obj_this = $(this);
				var add_cart_text = $(this).siblings(".j_AddCartText").eq(0);
				var old_qty = add_cart_text.val();
				add_cart_text.val(parseInt(add_cart_text.val()) + 1);
				
				if (add_cart_text.hasClass('j_AddCartTextCheckedMinQty')) {
					var min_qty = add_cart_text.attr('data-minqty');
					return update_qty(add_cart_text, min_qty, old_qty, obj_this);
				}
				
				change_tier_price(obj_this, add_cart_text);
				
				if (obj_this.parent().attr("data-is-cart")) {
					var key = obj_this.parents(".j_BatchCartBox").attr("data-key");
					var batch_text = $("#J_BatchNum-" + key);
					return update_qty(batch_text, '1', '1', obj_this);
				}
			});
		});
		$(".j_AddCartBtnReduce").each(function() {
			$(this).unbind("click").click(function() {
				var obj_this = $(this);
				var add_cart_text = $(this).siblings(".j_AddCartText").eq(0);
				var old_qty = add_cart_text.val();
			
				if (parseInt(add_cart_text.val()) > 0) {
					add_cart_text.val(parseInt(add_cart_text.val()) - 1);
					
					if (add_cart_text.hasClass('j_AddCartTextCheckedMinQty')) {
						var min_qty = add_cart_text.attr('data-minqty');
						return update_qty(add_cart_text, min_qty, old_qty, obj_this);
					}
				}
				
				change_tier_price(obj_this, add_cart_text);
				
				if (obj_this.parent().attr("data-is-cart")) {
					var key = obj_this.parents(".j_BatchCartBox").attr("data-key");
					var batch_text = $("#J_BatchNum-" + key);
					return update_qty(batch_text, '1', '1', obj_this);
				}
			});
		});
		function update_qty(obj_input, min_qty, old_qty, obj) {
			if (min_qty) {
				var new_qty = parseInt(obj_input.val());
				if (new_qty >= min_qty) {
					var url = GLOBAL.Config.base + "/cart/update/";
					var parameters = obj_input.attr("name") + "=" + new_qty;
					
					$.ajax({
						url : url,
						type : "post",
						data : parameters,
						dataType : "json",
						headers: {'X-Requested-With': 'XMLHttpRequest'},
						success: function(cart) {
							if (cart) {
								var obj_text_price = obj_input.parents("li").find(".j_AddCartTextPrice")[0];
								var obj_text_subtotal = obj_input.parents("li").find(".j_AddCartTextSubtotal")[0];
								var data_key = obj_input.attr("data-key");
							
								if (cart.qty > 0 && cart.product) {
									if (cart.currency == 'CNY') cart.currency = '￥ ';

									//cart
									var products = cart.product;
									for (var product in products ) {
										var key = products[product].front_gs_aid ? products[product].id + ';' + products[product].front_gs_aid : products[product].id;
										if (key == data_key) {
											var new_price = cart.currency + products[product].price;
											if ($.trim($(obj_text_price).text()) != "面议") {
												$(obj_text_price).html(new_price);
											}
											$(obj_text_subtotal).html(cart.currency + products[product].subtotal);
											break;
										}
									}
									$("#J_AddCartSubtotal").html(cart.currency + cart.subtotal);
									$("#J_AddCartSubtotalAll").html(cart.currency + cart.subtotal_all);
								}
							}
						},
						error: function(XMLHttpRequest, textStatus, errorThrown) {
							 //alert(XMLHttpRequest.status);
							 //alert(XMLHttpRequest.readyState);
							 //alert(textStatus);
						}
					});
					
					return true;
				} else {
					new Tips('最小订购量为' + min_qty);
					setTimeout(function() {
						$("#J_AppExitTipWarp").remove();
					}, 2000);
					if (obj_input.hasClass("j_BatchNum")) {
						obj.siblings(".j_AddCartText").eq(0).val(old_qty);
						var spec = obj.parents(".j_Spec").attr("data-spec");
						var price = obj.parents(".j_Spec").attr("data-price");
						obj.parents(".j_CartAttBox").find(".j_CartAttrPrice").text(price);
						obj_input.val(spec);//恢复旧值
					} else {
						obj_input.val(old_qty);//恢复旧值
					}
					return false;
				}
			} else {
				return true;
			}
		}
		
		function change_tier_price(obj, number) {
			// 加入购物车属性框价格变化
			obj_this = obj;
			add_cart_text = number;
			
			if (obj_this.attr("data-price-change") == "true") {
				var cur_number = add_cart_text.val();
				var tier_number = obj_this.parents(".j_CartAttBox").find(".j_Tier");
				var cartattribute_price = obj_this.parents(".j_CartAttBox").find(".j_CartAttrPrice");
				tier_number.each(function() {
					var text_number = $(this).text().replace(/\s/g, "");
					var tier_price = $(this).parent().find(".j_TierPrice").text().replace(/\s/g, "").replace("￥", "");
					
					// 判断是否为最后一个分级价格
					var isgt = text_number.indexOf('≥') != -1;
					if (isgt) {
						
						text_number = text_number.replace("≥", "");
						if (parseInt(cur_number) >= parseInt(text_number)) {
							cartattribute_price.text(tier_price);
						}
					} else {
						var array_number = text_number.split('-');
						var number_before = parseInt(array_number[0]);
						var number_after = parseInt(array_number[1]);
						if (array_number.length >= 2) {
							// 以左右插入节点
							if (parseInt(cur_number) >= number_before && parseInt(cur_number) <= number_after) {
								cartattribute_price.text(tier_price);
							}
						}  else {
							if (parseInt(cur_number) == number_before) {
								cartattribute_price.text(tier_price);
							}
						}
					}
				});
			} else if (obj_this.attr("data-price-batch") == "true") {
				// 判断输入值是否为空
				if (obj_this.val() == '') {
					obj_this.val("0");
				}
				
				// 购买总数
				var cart_qty = 0;
				obj_this.parents(".j_CartBatchBox").find(".j_AddCartText").each(function() {
					var cur_val = $(this).val();
					var cur_spec = $(this).parent().attr("data-spec");
					var cur_qty = parseInt(cur_val) * parseInt(cur_spec);
					cart_qty += cur_qty;
				});
				$(".j_CheckoutBtn").attr("data-qty", cart_qty);
				$(".j_AddCartBtn").attr("data-qty", cart_qty);
				
				// 购物车总数改变
				var is_cart = obj_this.parent().attr("data-is-cart");
				if (is_cart) {
					obj_this.parents(".j_BatchCartBox").each(function() {
						var cart_total_qty = 0;
						var key = $(this).attr("data-key");
						$(this).find(".j_BatchCartAdd").each(function() {
							var cur_val = $(this).val();
							var cur_spec = $(this).parent().attr("data-spec");
							var cur_qty = parseInt(cur_val) * parseInt(cur_spec);
							cart_total_qty += cur_qty;
						});
						$("#J_BatchNum-" + key).val(cart_total_qty);
					});
				}
				
				// 包装数量数组
				var array_spec = [];
				obj_this.parents(".j_CartBatchBox").find(".j_Spec").each(function() {
					var batch_spec = $(this).attr("data-spec");
					array_spec.push(batch_spec);
				});
				
				// 弹出最后一个规格数
				var pop_spec = array_spec.pop();
				// 购物总数
				var cart_num = parseInt(cart_qty);
				
				function check_tier(pop_spec, cart_num) {
					obj_this.parents(".j_CartBatchBox").find(".j_AddCartText").each(function() {
						// 当前包装量
						var cur_spec = $(this).parent().attr("data-spec");
						
						if (pop_spec == cur_spec) {
							// 舍去法取整
							var cur_num = Math.floor(parseInt(cart_num) / parseInt(cur_spec));
							// 余下总数
							cart_num = parseInt(cart_num) % parseInt(cur_spec);
							
							$(this).val(cur_num);
							
							// 判断数组是否空
							if (array_spec.length) {
								pop_spec = array_spec.pop();
								check_tier(pop_spec, cart_num);
							}
						}
						
					});
				}
				check_tier(pop_spec, cart_num);
				
				// 总价格
				var total_price = 0;
				obj_this.parents(".j_CartAttBox").find(".j_AddCartText").each(function() {
					var cur_num = $(this).val();
					var cur_price = $(this).parent().attr("data-price");
					cur_total_price = parseInt(cur_num) * parseInt(cur_price);
					total_price += cur_total_price;
				});
				obj_this.parents(".j_CartAttBox").find(".j_CartAttrPrice").text(total_price);
			}
		}
	}
};


//====================
//类：AJAX验证登录并获取会员信息
//====================
var Identity = function(url, obj_id_has, obj_id_no, obj_id_account) {
	this.initialize(url, obj_id_has, obj_id_no, obj_id_account);
};
Identity.prototype = {
	initialize : function(url, obj_id_has, obj_id_no, obj_id_account) {
		this.url = url;
		this.objIdHas = obj_id_has;
		this.objIdNo = obj_id_no;
		this.objIdAccount = obj_id_account;
		this.getData();
	},
	
	getData : function() {
		$.getJSON(this.url, $.proxy(this.setData, this));
	},
	
	setData : function(identity) {
		if (identity && identity.account) {
			$(this.objIdHas).show();
			$(this.objIdNo).hide();
			if ($(this.objIdAccount).length > 0) {
				if (identity.full_name) {
					$(this.objIdAccount).text(identity.full_name);
				} else {
					$(this.objIdAccount).text(identity.account);
				}
			}
		} else {
			$(this.objIdHas).hide();
			$(this.objIdNo).show();
		}
	}
};

//====================
//类：AJAX管理购物车
//====================
var Cart = function() {};
Cart.prototype = {
	fetch : function(url_fetch, obj_id_qty, obj_id_currency, obj_id_subtotal, is_product, transport) {
		this.urlFetch = url_fetch;
		this.objIdQty = obj_id_qty;
		this.objIdCurrency = obj_id_currency;
		this.objIdSubtotal = obj_id_subtotal;
		
		is_product = (is_product != undefined) ? true : false;
		transport = (transport != undefined) ? transport : null;
		
		if (transport) {
			this.setFetchData(transport);
		} else {
			this.getFetchData(is_product);
		}
	},
	
	getFetchData : function(is_product) {
		var url = this.urlFetch + '?is_product=' + is_product;
		$.getJSON(url, $.proxy(this.setFetchData, this));
	},
	
	setFetchData : function(transport) {
		var cart = transport;
		if (cart) {
			if ($(this.objIdQty).length > 0) $(this.objIdQty).text(cart.qty);
			if ($(this.objIdCurrency).length > 0) $(this.objIdCurrency).text(cart.currency);
			if ($(this.objIdSubtotal).length > 0) $(this.objIdSubtotal).text(cart.subtotal);
			
			if (cart.qty > 0 && cart.product) {
				
				if (cart.currency == 'CNY') cart.currency = '￥';
				var products = cart.product;
				var html = '';
				for (product in products ) {
					if (products[product].old_name == undefined) {
						html += '<div class="item clearfix"><div class="fl">';
						
						html += '<a href="' + products[product].path + '"><img src="' +
								products[product].picname[0]['t'] + '" /></a></div>';
						html += '<div class="name fl"><a href="' + products[product].path + '">' +
								products[product].name + '</a></div>';
						html += '<div class="detail fr"><span class="price"><strong>' +
								cart.currency + products[product].price + '</strong>×' +
								products[product].quantity + '</span><br /></div></div>';
					}
				}
				
				$('#J_MycartList').html(html);
				$('#J_MycartQty').text(cart.qty);
				$('#J_MycartSubtotal').text(cart.currency + cart.subtotal);
				
				$('#J_MycartListEmpty').hide();
				$('#J_MycartTotalBox').show();
			} else {
				$('#J_MycartListEmpty').show();
				$('#J_MycartTotalBox').hide();
			}
		}
	},
	
	add : function(url_add, url_cart, aid, qty, lancode, url_redirect) {
		this.urlAdd = url_add;
		this.urlCart = url_cart;
		this.urlRedirect = url_redirect;
		
		if (isNaN(qty) || qty <= 0)	{
			new Tips("请输入正确的数字！");
			setTimeout(function() {
				$("#J_AppExitTipWarp").remove();
			}, 2000);
			return false;
		}
		
		var qty_name;
		var parameters;
		
		var islogin = $("body").find("header").attr("data-islogin");
		if (islogin == 'false') {
			islogin = false;
		} else {
			islogin = true;
		}
		// 如果未登录，则显示登录窗口
		if (!islogin) {
			var login_redirect = $('.j_AddCartBtn').eq(0).attr('data-login-redirect');
			if (login_redirect) {
				// 标示为通过登录窗口登录
				$("body").find("header").attr("data-tologin", "true");
				qty_name = "qty[" + aid + "]=" + qty;
				var url = GLOBAL.Config.base + "/customer/login/?referer=L2NhcnQvP2w9emgtQ04=&" +
				 			"product=" + aid + "&" + qty_name;
				window.location = url;
			} else {
				// 调整窗口高度
				var t = $(window).scrollTop() + 100;
				$('#J_LoginWin').css("top", t);
				$('#J_LoginWin').show();
				$('#J_ThickDiv').show();
				$('#J_LoginWinProductAid').val(aid);
				$('#J_ThickDiv').css("opacity", "0.6");
				
				// 标示为通过登录窗口登录
				$("body").find("header").attr("data-tologin", "true");
				if (this.urlRedirect) $('#J_LoginWinRedirect').val(this.urlRedirect);
			}
			return false;
		}
		
		if ($('#J_AddCartAttrFrontForm').lenth) {//产品详情页，带前端属性attributefront
			var f = $('#J_AddCartAttrFrontForm').getElements();
			parameters = '';
			f.each(function() {
				parameters += "&" + $(this).attr("name") + "=" + $(this).val();
			});
		} else { // 列表页
			qty_name = "qty[" + aid + "]=" + qty;
			parameters = "l=" + lancode + "&product=" + aid + "&" + qty_name;
		}
		
		// 调整窗口高度
		var t = $(window).scrollTop();
		var h = $(window).height();
		t = t + h / 2 - 40;
		$('#J_AddCartWin').css("top", t);
		//各窗口开关
		$('#J_ThickDiv').show();
		$('#J_AddCartWin').show();
		$("#J_AddCartSuccess").hide();
		$('#J_AddCartLoading').show();
		$('#J_ThickDiv').css("opacity", "0.6");
		
		var obj_this = this;
		$.ajax({
			url : url_add,
			type : "post",
			data : parameters,
			dataType : "json",
			headers: {'X-Requested-With': 'XMLHttpRequest'},
			success: function(transport) {
				if (transport.errors != undefined) {
					// 各窗口开关
					$("#J_AddCartLoading").hide();
					$("#J_AddCartFail").show();
					$("#J_AddCartSuccess").hide();
					
					if (transport.errors.min_qty != undefined) {
						var product_id = transport.errors.min_qty[0];
						var min_qty = $("#J_AddCartQty-" + product_id).attr("data-minqty");
						var title = '该商品最小订购量为' + min_qty + '<br />请重新输入';
						$("#J_AddCartFailTitle").html(title);
					}
					
					if (transport.errors.cart_full != undefined) {
						var title = '购物车已满<br />您可以分成多个订单来结算';
						$("#J_AddCartFailTitle").html(title);
					}
					
					// 1秒隐藏窗口
					setTimeout(function() {
						$('#J_ThickDiv').hide();
						$('#J_AddCartWin').hide();
						$("#J_AddCartFail").hide();
						if ($("body").find("header").attr("data-tologin") == "true") {
							window.location.reload();
						}
					}, 1000);
				} else {
					obj_this.fetch(obj_this.urlCart, '#J_MycartQtyShort', '', '', true, transport);
					
					if (obj_this.urlRedirect) {
						window.location.href = obj_this.urlRedirect;
					} else {
						// 各窗口开关
						$("#J_AddCartLoading").hide();
						$("#J_AddCartFail").hide();
						$("#J_AddCartSuccess").show();
						
						// 1秒隐藏窗口
						setTimeout(function() {
							$('#J_ThickDiv').hide();
							$('#J_AddCartWin').hide();
							$("#J_AddCartSuccess").hide();
							if ($("body").find("header").attr("data-tologin") == "true") {
								window.location.reload();
							}
						}, 1000);
					}
				}
				
				// product详情页面检查属性中是否有参数
				if ($(".j_AddCartBtn").attr("data-redirect") != undefined) {
					window.location = $(".j_AddCartBtn").attr("data-redirect");
				}
				
				$(".j_AddCartClose").each(function() {
					$(this).click(function() {
						//各窗口开关
						$('#J_ThickDiv').hide();
						$('#J_AddCartWin').hide();
						$("#J_AddCartFail").hide();
						$("#J_AddCartSuccess").hide();
					});
				});
			},
			
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				// alert(XMLHttpRequest.status);
				// alert(XMLHttpRequest.readyState);
				 //alert(textStatus);
			}
		});
	}
};

Zepto(document).ready(function($) {
	//====================
	//内联脚本提取
	//====================
	(function($) {
		///百度地图API功能
		if ($("#J_BaiduMap").length > 0) {
			// 调整高度
			var height = $(window).height();
			$("#J_BaiduMap").css("height", height);
			
			var baidumap = new BaiduMap();
			// 首次创建地图
			baidumap.createMap();
			
			// 独立店铺，直接模拟跳到路线
			if ($("#J_CompanyMap").length > 0) {
				var bmapx = $(".j_MapCompanyList").attr("data-bmapx");
				var bmapy = $(".j_MapCompanyList").attr("data-bmapy");
				baidumap.mapInit(bmapx, bmapy);
				// 等待所有事件加载完成后执行(排除微信)
				if ($("#J_MapCompanyBox").attr("data-iswechat") != "true") {
					window.onload = function() {
						// 等待规划未响应调出面板
						new Tips("路线规划中，请稍后...");
						setTimeout(function() {
							$("#J_AppExitTipWarp").remove();
							if ($(".j_MapCompanyList").attr("data-distance") <= GLOBAL.Config.x_distance) {
								// 执行点击事件
								$(".j_MapCompanyLocation").trigger("click");
							}
						}, 2500);
					};
				}
				
				// 点击事件(避免重复执行结绑后执行)
				$(".j_MapCompanyList").each(function() {
					$(this).unbind("click").click(function() {
						// 移除默认值
						$(".j_MapCompanyList").each(function() {
							$(this).removeClass("cur");
						});
						$(this).addClass("cur");
						var bmapx = $(this).attr("data-bmapx");
						var bmapy = $(this).attr("data-bmapy");
						baidumap.mapInit(bmapx, bmapy);
					});
				});
			}
		}
	})(Zepto);
	//====================
	//轮播，放在全局供回调函数使用 
	//====================
	(function($) {
		// 首页轮播
		$('#J_Slide').swipeSlide({
			continuousScroll:true,
			speed : 3000,
			transitionType : 'cubic-bezier(0.22, 0.69, 0.72, 0.88)',
			firstCallback : function(i, sum, me) {
				me.find('.dot').children().first().addClass('cur');
			},
			callback : function(i, sum, me) {
				me.find('.dot').children().eq(i).addClass('cur').siblings().removeClass('cur');
			}
		});
		
		// 详情页轮播
		$('#J_ProductsSlide').swipeSlide({
			continuousScroll:true,
			speed : 300000,
			transitionType : 'cubic-bezier(0.22, 0.69, 0.72, 0.88)',
			firstCallback : function(i,sum){
				$('#J_SlidePre').text(i+1);
				$('#J_SlideAft').text(sum);
			},
			callback : function(i,sum){
				$('#J_SlidePre').text(i+1);
				$('#J_SlideAft').text(sum);
			}
		});
		
		// 详情页产品大图
		 $('#J_ProimgSlide').swipeSlide({
			continuousScroll:true,
			speed : 300000,
			transitionType : 'cubic-bezier(0.22, 0.69, 0.72, 0.88)',
			firstCallback : function(i,sum){
				$('#J_SlidePre').text(i+1);
				$('#J_SlideAft').text(sum);
			},
			callback : function(i,sum){
				$('#J_SlidePre').text(i+1);
				$('#J_SlideAft').text(sum);
			}
		 });
		
		// 详情页推荐更多
		$('.j_SlideRecommend').swipeSlide({
			continuousScroll:true,
			speed : 300000,
			transitionType : 'cubic-bezier(0.22, 0.69, 0.72, 0.88)',
			firstCallback : function(i,sum,me){
				me.find('.dot').children().first().addClass('cur');
			},
			callback : function(i,sum,me){
				me.find('.dot').children().eq(i).addClass('cur').siblings().removeClass('cur');
			}
		 });
	})(Zepto);
	
	//====================
	//后台评论
	//====================
	(function($) {
		// 折叠reviewsForm
		$(".j_AccountPageReviewsExpand").each(function() {
			var reviews_form = $(this).parents("li").eq(0).find(".j_ReviewsFormContainer").eq(0);
			$(this).click(function() {
				reviews_form.toggle();
				$(this).next().toggleClass("accountPage-reviewsListOperateIconExpand");
			});
		});
		
		// 应用于所有未评价商品
		$(".j_ReviewsFormSetDefault").each(function() {
			$(this).click(function() {
				var siblings_tr = $(this).parents("tr").eq(0).siblings();
				if (this.checked) {
					siblings_tr.each(function() {
						$(this).find("input").each(function() {this.disabled = true;});
						$(this).find("textarea").each(function() {this.disabled = true;});
						$(this).find("button").each(function() {this.disabled = true;});
					});
				} else {
					siblings_tr.each(function() {
						$(this).find("input").each(function(){this.disabled = false;});
						$(this).find("textarea").each(function() {this.disabled = false;});
						$(this).find("button").each(function(){this.disabled = false;});
					});
				}
			});
		});
		
		// 提交
		$(".j_ReviewsForm").each(function() {
			$(this).submit(function() {
				var comment_len = $(this.comment).val().length;
				if (comment_len < 2 || comment_len > 500) {
					var e = $(this.comment).next();
					e.fadeOut().fadeIn().addClass("warning").text('心得请控制在2-500字');
					return false;
				}
				
				var f = this;
				var container = $(this).parent();
				
				// 调整窗口高度
				var t = $(window).scrollTop();
				var h = $(window).height();
				t = t + h / 2 - 40;
				
				$('#J_LoadingWin').css("top", t);
				$("#J_LoadingWin").show();
				$("#J_ThickDiv").show();
				
				var url = GLOBAL.Config.base + $(this).attr("action");
				
				$.ajax({
					cache : true,
					async : true,
					type : "POST",
					url : url,
					data : $(this).serialize(),
					success : update_reviews
				});
				
				function update_reviews(transport) {
					if (transport != "error") {
						var t;
						
						var star = $(f.star).filter(":checked").val();
						t = '<li><strong class="reviewsForm-star"><span class="iconStar iconStar' + star + '">' + star + '颗星</span></strong><div>评论成功！</div></li>';
						$(f.star).parents("ul").eq(0).html(t);
						
						t = $(f.comment).val();
						$(f.comment).parent().text(t);

						$(f.set_default).parent().parent().remove();
						container.find("button").parent().remove();
					} else {
						new Tips("数据有误，请稍后重试！");
						setTimeout(function() {
							$("#J_AppExitTipWarp").remove();
						}, 2000);
					}

					$('#J_ThickDiv').hide();
					$("#J_LoadingWin").hide();
				}
				
				return false;
			});
			
		});
		
		// 星星
		$('.j_Star').each(function() {
			var ele_input = $(this).next();
			var option = {
				after_click : function(ret) {
					ele_input.val(ret.number);
				}
			};
			
			$(this).rater(option);
		});
	})(Zepto);
	
	//====================
	//支付页面弹窗
	//====================
	(function($) {
		// 订单提交提示，排除点击去付款的页面
		if ($("#J_PaymentSuccess").length > 0) {
			var path_params = window.location.search;
			var has_param = path_params.indexOf("topayment");
			if (has_param == "-1") {
				new Tips("订单提交成功！");
				setTimeout(function() {
					$("#J_AppExitTipWarp").remove();
				}, 2000);
			} 
		}
		
		$(".j_PaymentContentBtn").each(function() {
			$(this).click(function() {
				// 调整窗口高度
				var t = $(window).scrollTop();
				var h = $(window).height();
				t = t + h / 2 - 40;
				$('#J_PaymentWin').css("top", t);
				
				$('#J_PaymentWin').show();
				$('#J_ThickDiv').show();

				var f = $(this).siblings("form");
				if (f.length) {
					if ($(this).attr('data-redirect-pre')) {
						return false;
					} else {
						f[0].submit();
						return true;
					}
				}
			});
		});
		
		$("#J_PaymentGatewayClose").click(function() {
			$('#J_ThickDiv').hide();
			$('#J_PaymentWin').hide();
		});
		
	})(Zepto);
	
	//====================
	//加入购物车触发
	//====================
	(function($) {
		new GlobalBind();
	})(Zepto);
	
	
	//====================
	//下拉刷新上拉加载
	//====================
	(function($) {
		// 首页catalog分类下拉加载
		if ($("#J_CatalogMore").length > 0) {
			// 记录分类类目，最多9个
			var arr_aid = [];
			var arr_name = [];
			var arr_haschild = [];
			
			var catalog_count = $("#J_CatalogAid").find("li").length - 1;
			
			$("#J_CatalogAid").find("li").each(function() {
				var catalog_aid = $(this).attr("data-aid");
				var catalog_haschild = $(this).attr("data-haschild");
				var catalog_name = $(this).text();
				arr_aid.push(catalog_aid);
				if (catalog_count < 10) {
					arr_name.push(catalog_name);
					arr_haschild.push(catalog_haschild);
				}
			});
			if (catalog_count > 1) {
				// 初始化加载次数
				var counter = 0;
				
				$("#J_CatalogMore").dropload({
					scrollArea : window,
					loadDownFn : function(me) {
						var obj_this = this;
						var url = GLOBAL.Config.base + $("#J_CatalogMoreBox").attr("data-url");
						var cur_aid = $("#J_CatalogMoreBox").attr("data-aid");
						var pop_aid = arr_aid.shift();
						var pop_haschild = arr_haschild.shift();
						var pop_name = arr_name.shift();
						// 忽略全部类目
						if (pop_aid == cur_aid) {
							pop_aid = arr_aid.shift();
							pop_haschild = arr_haschild.shift();
							pop_name = arr_name.shift();
						}
						
						if (pop_aid != cur_aid && pop_aid != undefined && pop_aid != "all") {
							url = url + "&catalog=" + pop_aid + "&name=" + pop_name + "&haschild=" + pop_haschild;
							$.ajax({
								type: 'GET',
								url: url,
								success: function(data) {
									var dropload_nodata_text;
									if (data.indexOf('<empty></empty>') != -1) {
										if (arr_aid.length == "0" && pop_aid == "all") {
											obj_this.loadDownFn(me);
										} else {
											// 锁定
											me.lock();
											// 无数据
											me.noData();
											me.resetload();
											dropload_nodata_text = $(".dropload-noData").text();
											if (dropload_nodata_text != "") {
												$(".dropload-down").hide();
											}
										}
									} else {
										$("#J_CatalogMoreBox").append(data);
										
										// 加载完毕要重新加载邦定事件
										Zepto(".on_scroll_load_img").scrollLoading();
										new GlobalBind();
										
										// 每次数据加载完，必须重置
										
										me.resetload();
										if (arr_aid.length == "0" && pop_aid == "all") {
											// 锁定
											me.lock();
											// 无数据
											me.noData();
											me.resetload();
											dropload_nodata_text = $(".dropload-noData").text();
											if (dropload_nodata_text != "") {
												$(".dropload-down").hide();
											}
										}
									}
								},
								error: function(xhr, type){
									new Tips("数据有误，请稍后重试！");
									setTimeout(function() {
										$("#J_AppExitTipWarp").remove();
									}, 2000);
									// 即使加载出错，也得重置
									me.resetload();
								}
							});
						} else {
							// 锁定
							me.lock();
							// 无数据
							me.noData();
							me.resetload();
							var dropload_nodata_text = $(".dropload-noData").text();
							if (dropload_nodata_text != "") {
								$(".dropload-down").hide();
							}
						}
					}
				});
			}
		}
		
		// 各页面分页下拉加载
		if ($("#J_DroadLoad").length > 0) {
			// 当前页数默认为第一页
			var page = 2;
			// 总页数
			var page_total = $("#J_DroadLoad").attr("data-pagetotal");
			
			// 采用正则表达式获取地址栏参数
			function get_query_string(name) {
				var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
				var r = window.location.search.substr(1).match(reg);
				if (r != null) return unescape(r[2]);
				return null;
			}
			var param_page = parseFloat(get_query_string("p"));
			if (param_page && param_page != null) {
				page = param_page;
			}
			if (page_total > 1) {
				$("#J_DroadLoad").dropload({
					scrollArea : window,
					loadDownFn : function(me) {
						// 下拉加载确保从第二页开始
						if (page <= 1) {
							page = 2;
						}
						
						var url = GLOBAL.Config.base + $("#J_DroadLoad").attr("data-url");
						url = url + "&p=" + page;
						$.ajax({
							type: 'GET',
							url: url,
							success: function(data) {
								
								if (page <= page_total) {
									$("#J_DroadLoadBox").append(data);
									// 每次数据加载完，必须重置
									Zepto(".on_scroll_load_img").scrollLoading();
									new GlobalBind();
									
									me.resetload();
								}
								
								if (page == page_total) {
									// 锁定
									me.lock();
									// 无数据
									me.noData();
									me.resetload();
								}
								page ++;
							},
							error: function(xhr, type){
								new Tips("数据有误，请稍后重试！");
								setTimeout(function() {
									$("#J_AppExitTipWarp").remove();
								}, 2000);
								// 即使加载出错，也得重置
								me.resetload();
							}
						});
					},
					loadUpFn : function(me) {
						// 当返回的页面当前数为1时候不能上拉操作
						var back_page = parseFloat(get_query_string("p"));
						page --;
						if (page >= 1 && back_page > 1) {
							var url = GLOBAL.Config.base + $("#J_DroadLoad").attr("data-url");
							url = url + "&p=" + page;
							$.ajax({
								type: 'GET',
								url: url,
								success: function(data) {
									if (page <= page_total && page >= 1) {
										$("#J_DroadLoadBox").prepend(data);
										// 每次数据加载完，必须重置
										Zepto(".on_scroll_load_img").scrollLoading();
										new GlobalBind();
										
										me.resetload();
									}
									
									if (page == 1) {
										// 锁定
										me.lock();
										// 无数据
										me.noData();
										me.resetload();
									}
								},
								error: function(xhr, type){
									new Tips("数据有误，请稍后重试！");
									setTimeout(function() {
										$("#J_AppExitTipWarp").remove();
									}, 2000);
									// 即使加载出错，也得重置
									me.resetload();
								}
							});
						} else {
							// 锁定
							me.lock();
							// 无数据
							me.noData();
							me.resetload();
						}
					}
				});
			}
		}
		
		//====================
		//产品详情页跳转
		//====================
		if ($("#J_DroadLink").length > 0) {
			$("#J_DroadLink").dropload({
				scrollArea : window,
				loadDownFn : function(me) {
					var id = $("#J_DroadLink").attr("data-id");
					var url;
					if ($("#J_DroadLink").attr('data-redirect-pre')) {
						url = "./template.html?controller=product&action=details&id=" + id;
						window.location = url;
					} else {
						url = "/product/details/?id=" + id;
						window.location = url;
					}
				}
			});
		}
	})(Zepto);
	
	
	//====================
	//页面返回键跳转
	//====================
	(function($) {
		// 详情页跳转定位到列表商品中
		// 注意：需要定位返回的页面加上id=J_LocationPage
		if ($('#J_LocationPage').length > 0) {
			var url = window.location.href;
			var history = document.referrer;
			var re_params;
			if (history.indexOf('&p=') != -1) {
				re_params = history.substring(history.indexOf('&p='), history.length);
				history = history.replace(re_params, "");
			} else if (history.indexOf('?p=') != -1) {
				re_params = history.substring(history.indexOf('?p='), history.length);
				history = history.replace(re_params, "");
			}
			//alert(history);
			// 获取列表分页跟id
			var pro_aid = get_query_string("id");
			var page = get_query_string("page");
			
			$('#J_PageBack').click(function() {
				if (pro_aid != null && page != null && history) {
					if (history.indexOf("?") != -1) {
						history = history + "&p=" + page + "&toproid=" + pro_aid;
					} else {
						history = history + "?p=" + page + "&toproid=" + pro_aid;
					}
				}
				if (history) {
					window.location = history;
				} else {
					window.history.back();
				}
			});
		} else {
			// 返回键后退(判断是否点击返回顶部)
			 $('#J_PageBack').click(function() {
				var pro_aid = get_query_string("toproid");
				var a = window.location.href;
				if (/#/.test(a)) {
					window.history.go(-2);
					window.location.load(window.location.href);
				} else if (pro_aid != null && pro_aid && pro_aid != undefined) {
					window.history.go(-2);
				} else {
					window.history.back();
					window.location.load(window.location.href);
				}
			});
		}
		
		// 列表页判断地址是否存在定位，位置调整
		if ($("#J_DroadLoad").length > 0) {
			var pro_aid = get_query_string("toproid");
			if (pro_aid != null && pro_aid && pro_aid != undefined) {
				var scrllo_top = $("#J_Floor_" + pro_aid).offset().top - 85;
				$(window).scrollTop(scrllo_top);
			}
		}
		
		// 采用正则表达式获取地址栏参数
		function get_query_string(name) {
			var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
			var r = window.location.search.substr(1).match(reg);
			if (r != null) return unescape(r[2]);
			return null;
		}
	})(Zepto);
	
	
	//====================
	//杂七杂八
	//====================
	(function($) {
		// 选项卡
		$('#J_Tab').find("a").click(function() {
			var data = $(this).attr("data-value");
			$('#J_Tab').find("li").removeClass("on");
			$(this).parent().addClass("on");
			$(".j_TabList").hide();
			$("#" + data).css({"left":"20px","opacity":"0"}).show().animate({"left":"0", opacity: '1'});
		});	
		 
		// li列表点击隐现
		$(".j_ListToggle").each(function() {
			$(this).click(function() {
				var li_box = $(this).parent("li").find(".j_ListToggleBox");
				li_box.toggle();
				$(this).toggleClass("up");
			});
		});
		
		// li配送方式查看点击隐现
		$(".j_ShippingToggle").each(function() {
			$(this).click(function() {
				var li_box = $(this).parent().parent("li").find(".j_ShippingToggleBox");
				li_box.toggle();
				$(this).toggleClass("up");
			});
		});
		
		// li配送方式查看详情点击隐现
		$(".j_ListTabToggle").each(function() {
			$(this).click(function() {
				var li_box = $(this).parent().siblings(".j_ListTabToggleBox");
				li_box.toggle();
				$(this).find("span").toggleClass("checked");
			});
		});
		
		// 物流配送查询
		$(".j_ShippingChain").each(function() {
			$(this).click(function() {
				$("#J_ShippingChainBox").css("display", "block");
			});
		});
		$(".j_ShippingAddress").each(function() {
			$(this).click(function() {
				$("#J_ShippingAddressBox").css("display", "block");
			});
		});
		$(".j_ShppingClose").each(function() {
			$(this).click(function() {
				$(this).parents(".j_ShippingBox").css("display", "none");
			});
		});
		$(".j_ShippingBothers").each(function() {
			$(this).click(function() {
				$(this).parents("li").find(".j_ShippingBothersBox").css("display", "block");
			});
		});
		
		// 物流搜索栏浮动
		if ($("#J_ShippingFloatBar").length > 0) {
			$(window).scroll(function() {
				var scroll_top = $("#J_ShippingBanr").height();
				var top_height = parseFloat(scroll_top);
				if ($(this).scrollTop() > top_height) {
					$("#J_ShippingFloatBar").css("position", "fixed");
					$("#J_ShippingFloatBar").css("top", "40px");
				} else {
					$("#J_ShippingFloatBar").css("position", "relative");
					$("#J_ShippingFloatBar").css("top", "0");
				}
			});
		}
		
		// 支付方式少于两个，则默认打开
		if ($(".j_ListToggle").length <= 2) {
			$(".j_ListToggle").each(function() {
				$(this).parent().find(".j_ListToggleBox").show();
			});
		}
		
		// 查看订单筛选日期点击隐现
		$(".j_OrderToggle").click(function() {
			$(this).toggleClass("up");
			$(".j_OrderToggleBox").toggle();
			$(".j_OrderToggleBarrier").toggle();
		});
		
		$(".j_OrderToggleBarrier").click(function() {
			$(this).hide();
			$(".j_OrderToggleBox").hide();
		});
		
		// 更改page页面图片大小
		$('#J_pageImg').find('img').each(function() {
			$(this).css({"width":"100%" , "height":"auto" , "display":"block"});
		});
		
		// 修正轮播点slide水平居中
		$(".slide").find(".j_SlideDot").each(function() {
			var span = $(this).children('span');
			var number = span.length;
			var mrl = -(number * 14) / 2;
			$(this).css("margin-left" , mrl);
		});
		
		//product页面轮播图片自适应高度
		$("#J_ProductSlide").find("img").each(function() {
			$(this).load(function() {
				var h = $(this).height();
				//alert(h);
				if (h < 320) {
					$("#J_Slide").addClass("productSlide");
				}
			});
		});
		
		// 产品详情推荐轮播调整
		$(".j_SlideRecommend").each(function() {
			var obj_this = $(this);
			var li_len = obj_this.find("li").length;
			var a_len = obj_this.find("li").find("a").length;
			
			if (a_len <= "3") {
				obj_this.css("overflow", "hidden");
				obj_this.find("a").addClass("recommend");
				obj_this.find("a").find("img").css("position", "relative");
				obj_this.removeClass("slide");
			}
			if (li_len == "1") {
				obj_this.find(".j_SlideDot").hide();
			}
		});
		
		// 点击菜单切换隐藏div
		$(".j_CompanydepNav").each(function() {
			$(this).click(function() {
				$(".j_CompanyNavBox").each(function () {
					$(this).toggle();
				});
			});
		});
		// 点击分类菜单切换隐藏ul
		$(".j_CatalogList").each(function() {
			$(this).click(function() {
				$(this).parent().find('ul').toggle();
			});
		});

		
		// 点击空白隐藏div
		$(document).bind("click",function(e){
			var target = $(e.target);
			if (target.closest(".j_CompanydepNav").length == 0) {
				$(".j_CompanyNavBox").hide();
			}
		});
		 
		// 我的订单判断button
		$(".j_OrdervewBtn").each(function() {
			var len = $(this).find("button").length;
			if (len == 1) {
				$(this).find("button").css("width", "100%");
			} else if (len == 2) {
				$(this).find("button").each(function() {
					$(this).css("width", "50%");
				});
			}
		});
		 
		// checkout填写身份证提示
		$("#J_CheckoutForm").click(function() {
			if ($("#J_CheckoutShippingIdCard").length > 0) {
				new Tips("请补充身份证信息！");
				setTimeout(function() {
					$("#J_AppExitTipWarp").remove();
				}, 2000);
				
				return false;
			}
		});
		 
		//====================
		//验证表单validate
		//====================
		if ($("#J_ValidateForm").length > 0) {
			$(function(){
				$.mvalidateExtend({
					phone:{
						required : true,
						pattern : /^0?1[3|4|5|8][0-9]\d{8}$/,
						each:function() {},
						descriptions:{
							required : '<div class="field-invalidmsg">请输入手机号码</div>',
							pattern : '<div class="field-invalidmsg">您输入的手机号码格式不正确</div>',
							valid : '<div class="field-validmsg">正确</div>'
						}
					}
				});
				$("#J_ValidateForm").mvalidate({
					type:1,
					onKeyup:true,
					sendForm:true,
					firstInvalidFocus:false,
					valid:function(event,options){
						// 点击提交按钮时,表单通过验证触发函数
						$(".j_FromReset").each(function() {
							$(this).text("");
						});
						
						// 判断x版是否存在token
						var token = '';
						if ($("#J_ValidateForm").attr("data-token") != undefined) {
							token = $("#J_ValidateForm").attr("data-token");
						}
						
						// action为空时获取当前地址
						var action;
						if ($("#J_ValidateForm").attr("action") != '') {
							action = GLOBAL.Config.base + $("#J_ValidateForm").attr("action");
						} else {
							var data_url = $("#J_ValidateForm").attr("data-url");
							if (data_url != undefined) {
								action = GLOBAL.Config.base + data_url + window.location.search;
							} else {
								action = window.location.href;
							}
						}
						
						if (action.indexOf("?") != -1) {
							action = action + "&token=" + token;
						} else {
							action = action + "?token=" + token;
						}
						
						var form_value = $("#J_ValidateForm").serialize();
						var data;
						if (form_value != '' && form_value != undefined) {
							data = form_value;
						} else {
							data = '';
						}
						var options = {
							url: action,
							type: 'post',
							data: data,
							headers: {'X-Requested-With': 'XMLHttpRequest'},
							success: function (result) {
								if (result.errors != undefined && result.errors != '') {
									var data = result.errors;
									$.each(data, function(key, value) {
										if (key == 'error') {
											$.each(value, function(key, value) {
												if (key == 'account') {
													$.each(value, function(key, value) {
														$("#J_FormError-account").text(value);
													});
												} else if (key == 'captcha') {
													$.each(value, function(key, value) {
														$("#J_FormError-captcha").text(value);
													});
												}
											});
										} else {
											var obj_Element = $("#J_FormError-" + key);
											if (obj_Element.length > 0) {
												$.each(value, function(key, value) {
													obj_Element.text(value);
												});
											}
										}
									});
									
								} else if (result.edit_success != undefined) {
									$("#J_EditSuccess").text("信息更新成功。");
								} else {
									if (result.redirect) {
										if ($("#J_ValidateForm").attr('data-redirect-pre')) {
											var url = './template.html?';
											url += 'controller=' + result.redirect.controller;
											url += '&action=' + result.redirect.action;
											url += '&' + result.redirect.params;
											window.location = url;
										} else {
											window.location = result.redirect.url;
										}
									} else {
										window.location.reload();
									}
								}
							}
						};
						$.ajax(options);
						event.preventDefault();
					},
					invalid:function(event, status, options){
						// 点击提交按钮时,表单未通过验证触发函数
					},
					eachField:function(event,status,options){
						// 点击提交按钮时,表单每个输入域触发这个函数 this 执向当前表单输入域，是Zepto对象
					},
					eachValidField:function(val){},
					eachInvalidField:function(event, status, options){},
					conditional:{
						confirmpwd:function(){
							return $("#j_Password").val()==$("#j_PasswordConfirmation").val();
						},
						passwordsize:function(){
							return $("#j_Password").val().length >= 8;
						}
					},
					descriptions:{
						username:{
							required : '请输入用户名'
						},
						oldpassword:{
							 required : '请输入旧密码'
						},
						password:{
							 required : '请输入密码',
							 conditional : '密码长度小于8位'
						},
						confirmpassword:{
							required : '请再次输入密码',
							conditional : '两次密码不一样'
						}
					}
				});
			});
		}
		
	})(Zepto);
	
	//====================
	//footer点击返回顶部
	//====================
	(function($) {
		var return_top = $('#J_GoTop');
		return_top.click(function() {
			// 滚动到开始位置
			$("html,body").animate({scrollTop:0}, 500);
		});
		$(window).scroll(function() {
			if ($(this).scrollTop() > 400) {
				return_top.show();
			} else {
				return_top.hide();
			}
		});
	})(Zepto);
	
	//====================
	//价格小数点后样式改变
	//====================
	(function($) {
		$(".price").each(function() {
			var text_price = $(this).text();
			// 判断是否含有￥
			var price = trim(text_price).split('￥');
			if (!price[0] && Number(price[1])) {
				// 以小数点分隔左右插入节点
				var pot_before = price[1].split('.')[0];
				var pot_after = price[1].split('.')[1];
				// 判断是否有小数点
				if (pot_after != undefined) {
					var price_html = '<span class="price-currency">￥</span>' + pot_before + '.<span class="price-small">' + pot_after + '</span>';
					$(this).html(price_html);
				}
			}
		});
		
		function trim(str) { 
			return str.replace(/(^\s*)|(\s*$)/g, "");
		}
	})(Zepto);
	
	
	//====================
	//搜索框相关
	//====================
	(function($) {
		// 点击submit模拟提交
		$(".j_form").submit(function() {
			var action = $("#J_SearchBtn").parents("form").attr("action");
			var params = $("#J_SearchBtn").parents("form").serialize();
			if ($("#J_SearchBtn").attr('data-redirect-pre')) {
				var url = action + params;
				window.location = url;
			} else {
				var url = action + "?" + params;
				window.location = url;
			}
			return false;
			
		});
		
		// 搜索框清空
		$("#J_SearchClear").click(function() {
			$(".j_searchkey").val("");
		});
		
		// 搜索提交
		$("#J_SearchBtn").click(function() {
			var action = $(this).parents("form").attr("action");
			var params = $(this).parents("form").serialize();
			if ($(this).attr('data-redirect-pre')) {
				var url = action + params;
				window.location = url;
			} else {
				var url = action + "?" + params;
				window.location = url;
			}
		});
		
		// 搜索框窗口出现
		$(".j_SearchBtn").each(function() {
			$(this).click(function() {
				$(".j_WinHidden").css("display", "none");
				$(".j_SearchWin").css("display", "block");
			});
		});
		
		// 搜索框窗口返回
		$("#J_SearchBack").click(function() {
			$(".j_WinHidden").css("display", "block");
			$(".j_SearchWin").css("display", "none");
		});
		
		
		// 订单搜索框窗口返回
		$("#J_SearchReload").click(function() {
			$(".j_WinHidden").css("display", "block");
			$(".j_SearchWin").css("display", "none");
		});
		
		// 点货搜索切换搜索类型
		$(".j_SearchRadio").each(function() {
			$(this).click(function() {
				$(".j_SearchRadio").each(function() {
					$(this).removeClass("on");
				});
				$(this).addClass("on");
				$(this).parents(".j_SearchWin").find(".j_SearchType").val($(this).attr("data-type"));
			});
		});
		
	})(Zepto);
	
	//====================
	//非表单ajax提交数据
	//====================
	(function($) {
		$(".j_AjaxSubmit").each(function() {
			$(this).click(function() {
				var action = GLOBAL.Config.base + $(this).attr("data-action");
				var form_value = $(this).parents("form").serialize();
				if (form_value != '' && form_value != undefined) {
					var data = form_value;
				} else {
					var data = '';
				}
				//请求提示
				new Tips("加载中，请稍后...");
				
				var obj_this = $(this);
				var options = {
					url: action,
					type: 'post',
					data: data,
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function (result) {
						//提示消失
						setTimeout(function() {
							$("#J_AppExitTipWarp").remove();
						}, 2000);
						
						if (result.errors != undefined && result.errors != '') {
							if (result.errors.session_expired) {
								new Tips("订单已过期！");
								setTimeout(function() {
									$("#J_AppExitTipWarp").remove();
								}, 2000);
								
								if ($("#J_AddressShip").val() == '') {
									new Tips('请选择一个收货地址');
									setTimeout(function() {
										$("#J_AppExitTipWarp").remove();
									}, 2000);
									return false;
								} else if ($("#J_Shipping").val() == '') {
									new Tips('请选择一种配送方式');
									setTimeout(function() {
										$("#J_AppExitTipWarp").remove();
									}, 2000);
									return false;
								} else if (obj_this.attr('data-redirect-pre')) {
									var url = './template.html?';
									url += 'controller=' + result.redirect.controller;
									url += '&action=' + result.redirect.action;
									url += '&' + result.redirect.params;
									window.location = url;
								} else {
									window.location = result.redirect.url;
								}
							} else if (result.errors.accountname_not_exists) {
								$("#J_Errors-accountname").text("错误：很抱歉，您输入的帐户名不存在");
							} else {
								new Tips("errors: " + result.errors);
								setTimeout(function() {
									$("#J_AppExitTipWarp").remove();
								}, 2000);
							}
						} else {
							if (result.redirect) {
								if (obj_this.attr('data-redirect-pre')) {
									var url = './template.html?';
									url += 'controller=' + result.redirect.controller;
									url += '&action=' + result.redirect.action;
									url += '&' + result.redirect.params;
									window.location = url;
								} else {
									window.location = result.redirect.url;
								}
							} else {
								window.location.reload();
							}
						}
					}
				};
				$.ajax(options);
				return false;
			});
		});
	})(Zepto);
	
	//====================
	//通过ajax来删除数据
	//====================
	(function($) {
		$('.j_AjaxDelete').each(function() {
			$(this).click(function() {
				var action = GLOBAL.Config.base + $(this).attr("data-action");
				var obj_this = $(this);
				var options = {
					url: action,
					type: 'post',
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function (result) {
						if (result.redirect) {
							if (obj_this.attr('data-redirect-pre')) {
								var url = './template.html?';
								url += 'controller=' + result.redirect.controller;
								url += '&action=' + result.redirect.action;
								url += '&' + result.redirect.params;
								window.location = url;
							} else {
								window.location = result.redirect.url;
							}
						} else {
							window.location.reload();
						}
					}
				};
				var message = "确定要清除该数据吗？";
				new Confirms(message,
					function () {
						$.ajax(options);
					},
					function() {
						return false;
					}
				);
			});
		});
	})(Zepto);
	
	//====================
	//判断产品列表超出数量后收展
	//====================
	(function($) {
		 $(".j_ProductListToggle").each(function() {
			 var obj_this = $(this);
			 var len = $(this).find("li").length;
			 
			 $(".j_ProductListHide").css("display", "none");
			 
			 if (len > 3) {
				 var more_url = obj_this.attr("data-url");
				 var more_open = '<div class="productList-toggle j_ProductListMore">展开更多<span></span></div>';
				 var more_hide = '<div class="productList-toggle up j_ProductListHide">收起<span></span></div>';
				 var more_product = '<div class="productList-toggle"><a href="'+ more_url +'">查看更多商品</a></div>';
				 obj_this.find("li").each(function() {
					 $(this).css("display", "none");
				 });
				 
				 //隐藏其他节点只显示前3个
				 obj_this.find("li:first-child").css("display", "block");
				 obj_this.find("li:nth-child(2)").css("display", "block");
				 obj_this.find("li:nth-child(3)").css("display", "block");
				 //隐藏第三个节点的border
				 obj_this.find("li:nth-child(3)").find(".j_ProductListBar").css("border-color", "#FFFFFF");
				 obj_this.find("li:nth-child(3)").append(more_open);
				 
				 if (len > 9) {
					 obj_this.find("li:last").append(more_product);
				 } else {
					 obj_this.find("li:last").append(more_hide);
				 }
			 }
		 });
		 $(".j_ProductListMore").each(function() {
			 $(this).click(function() {
				 $(this).hide();
				 $(this).parent().parent("ul").find("li").each(function() {
					 $(this).css("display", "block");
					 $(this).find(".j_ProductListBar").css("border-color", "#E7E7E7");
				 });
				$(".j_ProductListHide").css("display", "inline-block");
			 });
		 });
		 
		 $(".j_ProductListHide").click(function() {
			 $(this).css("display", "none");
			 $(this).parent().parent("ul").find("li").each(function() {
				 $(this).css("display", "none");
			 });
			 $(this).parent().parent("ul").find("li:first-child").css("display", "block");
			 $(this).parent().parent("ul").find("li:nth-child(2)").css("display", "block");
			 $(this).parent().parent("ul").find("li:nth-child(3)").css("display", "block");
			 $(this).parent().parent("ul").find("li:nth-child(3)").find(".j_ProductListBar").css("border-color", "#FFFFFF");
			 $(this).parent().parent("ul").find(".j_ProductListMore").show();
		 });
	})(Zepto);
	
	//====================
	//筛选搜索栏
	//====================
	(function($) {
		//遍历所有选择区域，取出默认值
		$(".j_FilterBox").each(function() {
			//将选择内容放到选择区域中－多选
			var arr_filter_default_opt = [];
			$(".j_FilterSelect").each(function() {
				var filter_val = $(this).text();
				var has_select = $(this).hasClass("select");
				if (has_select) {
					arr_filter_default_opt.push(filter_val);
					var filter_opt_val = arr_filter_default_opt.join(',');
					$(this).parent().parent("li").find(".j_FilterOpt").text(filter_opt_val);
				} 
			});

			//将选择内容放到选择区域中－单选
			$(".j_FilterRadio").each(function() {
				var filter_val = $(this).text();
				var has_select = $(this).hasClass("select");
				if (has_select) {
					$(this).parent().parent("li").find(".j_FilterOpt").text(filter_val);
				}
			});
			
			//价格区间name
			$(".j_FilterPrice").each(function() {
				if (parseFloat($("#J_FilterPriceFrom").val()) < parseFloat($("#J_FilterPriceTo").val())) {
					$("#J_FilterPriceFrom").attr("name", "filter[price][from]");
					$("#J_FilterPriceTo").attr("name", "filter[price][to]");
				} else {
					$("#J_FilterPriceFrom").attr("name", "");
					$("#J_FilterPriceTo").attr("name", "");
				}
			});
			
			$(".j_FilterOpt").each(function() {
				var filter_opt_val = $(this).text();
				//去除空字符串
				if ($.trim(filter_opt_val) == '') {
					$(this).text(" ");
					$("#J_FisterBtn").removeClass("on");
				} else {
					//有筛选时筛选栏变红,没有内容时默认
					//$("#J_FisterBtn").addClass("on");
				}
			});
		});
		
		//多选
		$(".j_FilterSelect").each(function() {
			$(this).click(function() {
				$(this).toggleClass("select");
				var filter_val = $(this).text();
				var has_select = $(this).hasClass("select");

				//将选择内容放到选择区域中
				var arr_filter_opt = [];
				$(this).parent().find('.select').each(function() {
					arr_filter_opt.push($(this).text());
				});
				var filter_opt_val = arr_filter_opt.join(',');
				$(this).parent().parent("li").find(".j_FilterOpt").text(filter_opt_val);
				
				//将选择值放入input中
				if (has_select) {
					var data_filter_name = $(this).attr("data-filter-name");
					var data_filter_value = $(this).attr("data-filter-value");
					var input_hidden = '<input type="hidden" name="' + data_filter_name + '" value="'+ data_filter_value +'" />';
					$(this).append(input_hidden);
				} else {
					$(this).find("input").each(function() {
						$(this).remove();
					});
				}
			});
		});
		
		//单选
		$(".j_FilterRadio").each(function() {
			$(this).click(function() {
				//清除所有选项
				$(".j_FilterRadio").each(function() {
					$(this).removeClass("select");
					$(this).find("input").each(function() {
						$(this).remove();
					});
				});
				
				//添加CSS
				$(this).addClass("select");
				
				//将选择内容放到选择区域中
				var filter_opt_val = $(this).text();
				$(this).parent().parent("li").find(".j_FilterOpt").text(filter_opt_val);
				
				//将选择值放入input中
				var data_filter_name = $(this).attr("data-filter-name");
				var data_filter_value = $(this).attr("data-filter-value");
				var input_hidden = '<input type="hidden" name="' + data_filter_name + '" value="'+ data_filter_value +'" />';
				$(this).append(input_hidden);
			});
		});
		
		//价格区间
		$(".j_FilterPrice").each(function() {
			$(this).change(function() {
				if (parseFloat($("#J_FilterPriceFrom").val()) < parseFloat($("#J_FilterPriceTo").val())) {
					$("#J_FilterPriceFrom").attr("name", "filter[price][from]");
					$("#J_FilterPriceTo").attr("name", "filter[price][to]");
				} else {
					$("#J_FilterPriceFrom").attr("name", "");
					$("#J_FilterPriceTo").attr("name", "");
				}
			});
		});
		
		//清空筛选
		$("#J_FilterClear").click(function() {
			$(".j_FilterSelect").each(function() {
				$(this).removeClass("select");
				$(this).find("input").each(function() {
					$(this).remove();
				});
			});
			
			$(".j_FilterRadio").each(function() {
				$(this).removeClass("select");
				$(this).find("input").each(function() {
					$(this).remove();
				});
			});
			
			$(".j_FilterPrice").each(function() {
				$(this).val("");
			});
			
			$(".j_FilterOpt").each(function() {
				$(this).html(" ");
			});
		});
		
		//确定筛选
		$("#J_FilterBtn").click(function() {
			var controller = $(this).attr("data-controller");
			var action = $(this).attr("data-action");
			var form_value = $(this).parents("form").serialize();
			if ($(this).attr('data-redirect-pre')) {
				var url = './template.html?';
				url += 'controller=' + controller;
				url += '&action=' + action;
				url += '&' + form_value;
				window.location = url;
			} else {
				var url = "/" + controller + "/" + action + "/?" + form_value;
				window.location = url;
			}
			return false;
		});
	})(Zepto);
	
	
	//====================
	//订单相关
	//====================
	(function($) {
		var params_str = 'number=' + $("#J_CustomerOrderViewNumber").val();
		params_str += '&l=' + GLOBAL.Config.lancode;
		if ($("#J_CustomerOrderViewKey").length > 0) 
			params_str += '&key=' + $("#J_CustomerOrderViewKey").val();
		
		$("#J_CustomerOrderViewReorder").click(function() {
			var obj_this = $(this);
			var message = "本订单中的产品将添加到购物车（系统将自动排除缺货产品）";
			new Confirms(message,
				 function () {
					var url = GLOBAL.Config.base + '/customer/reorder/?' + params_str;
					orderSubmit(obj_this, url);
				},
				function() {
					return false;
				}
			);
		});
		
		$("#J_CustomerOrderViewCount").click(function() {
			if ($(this).attr('data-redirect-pre')) {
				var url = './template.html?';
				url += 'controller=customer';
				url += '&action=ordercount';
				url += '&' + params_str;
				window.location = url;
			} else {
				var url = GLOBAL.Config.base + '/customer/ordercount/?' + params_str;
				window.location = url;
			}
			
			
		});
		
		$("#J_CustomerOrderViewConfirm").click(function() {
			var obj_this = $(this);
			var message = "确认已收到货物？";
			new Confirms(message,
				 function () {
					var url = GLOBAL.Config.base + '/customer/orderconfirm/?' + params_str;
					orderSubmit(obj_this, url);
				},
				function() {
					return false;
				}
			);
		});
		
		$("#J_CustomerOrderViewCancel").click(function() {
			var obj_this = $(this);
			var message = "确定取消本订单？";
			new Confirms(message,
				 function () {
					var url = GLOBAL.Config.base + '/customer/ordercancel/?' + params_str;
					orderSubmit(obj_this, url);
				},
				function() {
					return false;
				}
			);
		});
		
		function orderSubmit(obj_this, url) {
			var options = {
				url: url,
				type: 'post',
				headers: {'X-Requested-With': 'XMLHttpRequest'},
				success: function (result) {
					if (obj_this.attr('data-redirect-pre')) {
						var url = './template.html?';
						url += 'controller=' + result.redirect.controller;
						url += '&action=' + result.redirect.action;
						url += '&' + result.redirect.params;
						window.location = url;
					} else {
						window.location = result.redirect.url;
					}
				}
			};
			$.ajax(options);
		}
		
	})(Zepto);
	
	
	//====================
	//点货相关
	//====================
	(function($) {
		//点击点货按钮
		$(".j_CountProduct").each(function() {
			$(this).click(function() {
				$(this).parents('li').find(".j_CountBarrier").show();
				$(this).parents('li').find(".j_CountProductBox").show();
			});
		});
		
		// 关闭窗口
		$(".j_CountClose").click(function() {
			$(".j_CountBarrier").hide();
			$(".j_CountProductBox").hide();
		});
		
		$(".j_CountBarrier").click(function() {
			$(".j_CountBarrier").hide();
			$(".j_CountProductBox").hide();
		});

		// 提交点货数量
		$(".j_CountProductBtn").each(function() {
			$(this).click(function() {
				var e = $(this).parent().find(".j_AddCartText");
				
				var url = GLOBAL.Config.base + '/customer/ordercountupdateajax/';
				var data = {'id' : e.attr('data-id'), 'amount' : e.val()};
				var options = {
					url: url,
					type: 'post',
					data: data,
					success: function (transport) {
						// 更新点货状态
						if (transport == 'error') {
							new Tips("点货失败");
							setTimeout(function() {
								$("#J_AppExitTipWarp").remove();
							}, 2000);
						} else {
							var str = '';
							if (transport.lack) {
								str += '<div class="countProduct-listBtnTip fl">已点' + transport.amount + '个, <label>缺' + transport.lack + '个</label></div>';
							}
							if (transport.over) {
								str += '<div class="countProduct-listBtnTip fl">已点' + transport.amount + '个, <label>多出' + transport.over + '个</label></div>';
							}
							if (transport.status == 'finish') {
								str += '<span class="j_CountProduct countProduct-listBtnOk button fr">收齐<span></span></span>';
							} else if (transport.status == 'over') {
								str += '<span class="j_CountProduct countProduct-listBtnOk button fr">多出<span></span></span>';
							} else if (transport.status == 'lack') {
								str += '<span class="j_CountProduct countProduct-listBtnOk button fr">缺货<span></span></span>';
							} else {
								str += '<span class="j_CountProduct countProduct-listBtnCount button fr">点货</span>';
							}
							
							$('#J_CountProductStatus-' + transport.id).html(str);
							
							// 点击点货按钮
							$(".j_CountProduct").each(function() {
								$(this).click(function() {
									$(this).parents('li').find(".j_CountBarrier").show();
									$(this).parents('li').find(".j_CountProductBox").show();
								});
							});
						}
						
						// 关闭窗口
						$(".j_CountBarrier").hide();
						$(".j_CountProductBox").hide();
					}
				};
				$.ajax(options);
			});
		});
		
		// 重新点货
		$("#J_CountProductRestart").click(function() {
			var url = GLOBAL.Config.base + $(this).attr('href');
			var options = {
				url: url,
				type: 'get',
				headers: {'X-Requested-With': 'XMLHttpRequest'},
				success: function (transport) {
					if (transport.errors != undefined) {
						new Tips(transport.errors.sell_out);
						setTimeout(function() {
							$("#J_AppExitTipWarp").remove();
						}, 2000);
					} else if (transport.redirect != undefined) {
						if ($(this).attr('data-redirect-pre')) {
							var url = './template.html?';
							url += 'controller=' + transport.redirect.controller;
							url += '&action=' + transport.redirect.action;
							url += '&' + transport.redirect.params;
							window.location = url;
						} else {
							window.location = transport.redirect.url;
						}
					}
				}
			};
			$.ajax(options);
			
			return false;
		});
	})(Zepto);
	
	
	//====================
	//地址相关
	//====================
	(function($) {
		
		// 选择地址
		$(".j_CheckoutCartCheck").each(function() {
			$(this).click(function() {
				var data_id = $(this).attr("data-id");
				$(this).find(".j_CartChecked").addClass("on");
				if ($(this).attr('data-redirect-pre')) {
					var url = "./template.html?controller=cart&action=checkout&address_ship=" + data_id;
					window.location = url;
				} else {
					window.location= GLOBAL.Config.base + '/cart/checkout/?address_ship='+ data_id;
				}
			});
		});
		
		// 选择配送方式
		$(".j_ShippingCheck").each(function() {
			$(this).click(function() {
				$(".j_ShippingCheck").each(function() {
					$(this).removeClass("on");
				});
				$(this).addClass("on");
				$("#J_CheckoutShippingFormShipping").val($(this).attr("data-code"));
			});
		});
		
		// 管理地址点击所在地区弹出
		$("#J_AddressEditCheck").click(function() {
			$("#J_AddressEditBox").show();
			$("#J_ThickDiv").show();
		});
		
		// 详细地址可编辑div替换input值
		$("#J_AddressSubmit").click(function() {
			var detail_address = $("#J_EditBox").text();
			if (detail_address == '') {
				new Tips("请填写详细地址！");
				setTimeout(function() {
					$("#J_AppExitTipWarp").remove();
				}, 2000);
				return false;
			}
			$("#J_EditVal").val(detail_address);
			return true;
		});
		
		// 默认地址切换
		$("#J_AddressAuto").click(function() {
			$(this).toggleClass("checked");
			
			if ($(this).hasClass("checked")) {
				$("#J_AddressAutoInput").val("Yes");
			} else {
				$("#J_AddressAutoInput").val("No");
			}
		});
		
		// 确定地址
		$("#J_AddressEditBtn").click(function() {
			var arr_val = [];
			$("#J_AddressEditBox").find("select option:selected").each(function() {
				var select_val = $(this).text();
				if (select_val != '-请选择-') {
					arr_val.push(select_val);
				}
			});
			arr_val = arr_val.join('-');
			$("#J_AddressEditValue").text(arr_val);
			$("#J_AddressEditValue").css("color", "#5B5B5B");
			$("#J_AddressEditValue").css("text-align", "left");
			$("#J_AddressEditBox").hide();
			$("#J_ThickDiv").hide();
		});
	
		// 确定配送方式
		$("#J_ShippingSubmit").click(function() {
			var form_value = $(this).parents("form").serialize();
			if ($(this).attr('data-redirect-pre')) {
				var url = './template.html?';
				url += 'controller=cart';
				url += '&action=checkout';
				url += '&' + form_value;
				window.location = url;
			} else {
				var url = "/cart/checkout" + "/?" + form_value;
				window.location = url;
			}
			return false;
		});
	})(Zepto);
	
	
	//====================
	//申请议价
	//====================
	(function($) {
		// 产品详情页
		$("#J_Bargining").click(function() {
			$("#J_ThickDiv").show();
			$(".j_BarginingBox").show();
		});
		
		// 列表
		$(".j_Bargining").each(function() {
			$(this).click(function() {
				$("#J_ThickDiv").show();
				$(this).parent().find(".j_BarginingBox").show();
			});
		});
		
		
		// 关闭
		$(".j_BarginingClose").each(function() {
			$(this).click(function() {
				$("body").find(".j_BarginingBox").each(function() {
					$(this).hide();
				});
				$("#J_ThickDiv").hide();
			});
		});
		
		// 触发后关闭
		$(".j_BarginingBtn").each(function() {
			$(this).click(function() {
				$("#J_ThickDiv").hide();
				$(".j_BarginingBox").each(function() {
					$(this).hide();
				})
			});
		});
		
		$("#J_ThickDiv").click(function() {
			$("#J_ThickDiv").hide();
			$(".j_BarginingBox").each(function() {
				$(this).hide();
			});
		});
		
	})(Zepto);
	
	//====================
	//购物车产品数量
	//====================
	(function($) {
		if ($('#J_MycartQtyShort').length > 0) {
			
			var islogin = $("body").find("header").attr("data-islogin");
			if (islogin == 'false') {
				islogin = false;
			} else {
				islogin = true;
			}
			//登录后才加载
			if (islogin) {
				var url = GLOBAL.Config.base + "/cart/cartajax/";
				var obj_cart = new Cart();
				obj_cart.fetch(url, '#J_MycartQtyShort', '', '', false);
			}
		}
	})(Zepto);
	
	//====================
	//加入收藏夹
	//====================
	(function($) {
		$(".j_AddFavor").each(function() {
			var obj_this = $(this);
			$(this).click(function() {
				function add_success(transport) {
					if (is_wishlist) {
						obj_this.find('span').removeClass('on');
						obj_this.find('span').text("收藏");
						obj_this.attr("data-is-wishlist", 0);
					} else {
						obj_this.find('span').addClass('on');
						obj_this.find('span').text("已收藏");
						obj_this.attr("data-is-wishlist", 1);
					}
				}
				
				var aid = $(this).attr("data-aid");
				var is_wishlist = parseInt($(this).attr("data-is-wishlist"));
				
				var islogin = $("body").find("header").attr("data-islogin");
				if (islogin == 'false') {
					islogin = false;
				} else {
					islogin = true;
				}
				//如果未登录，则显示登录窗口
				if (!islogin) {
					var login_redirect = $('.j_AddFavor').eq(0).attr('data-login-redirect');
					if (login_redirect) {
						//标示为通过登录窗口登录
						$("body").find("header").attr("data-tologin", "true");
						var url = GLOBAL.Config.base + "/customer/login/?" +
						 		"productid=" + aid + "&is_delete=" + is_wishlist;
						window.location = url;
					} else {
						//调整窗口高度
						var t = $(window).scrollTop()+100;
						$('#J_LoginWin').css("top", t);
					
						$('#J_LoginWin').show();
						$('#J_ThickDiv').show();
						$('#J_LoginWinProductAid').val("");
						$('#J_ThickDiv').css("opacity", "0.6");
						//标示为通过登录窗口登录
						$("body").find("header").attr("data-tologin", "true");
					}
					return false;
				}
				
				var url = GLOBAL.Config.base + "/customerwishlist/edit/" + '?productid=' + aid + '&is_delete=' + is_wishlist;
				$.get(url, add_success);
			});
		});
	})(Zepto);
	
	
	//====================
	//购物车是否全选
	//====================
	(function($) {
		/*购物车是否选择商品*/
		$('.j_CartCheck').each(function() {
			$(this).click(function() {
				if ($(this).hasClass('checked')) {
					$(this).removeClass('checked');
				} else {
					$(this).addClass('checked');
				}
			});
		});
			
		/*购物车编辑是否选择商品*/
		$('.j_CartEditCheck').each(function() {
			$(this).click(function() {
				if ($(this).hasClass('checked')) {
					$(this).removeClass('checked');
				} else {
					$(this).addClass('checked');
				}
			});
		});
		
		/*购物车编辑是否全选*/
		$('.j_EditIcon').each(function() {
			$(this).click(function() {
				var checkboxs = $(this).parents('form').eq(0).find('.j_CartEditCheck');
				if ($('.j_EditIcon').hasClass('checked')) {
					$('.j_EditIcon').removeClass('checked');
					checkboxs.each(function() {
						$(this).removeClass('checked');
					});
				} else {
					$('.j_EditIcon').addClass('checked');
					checkboxs.each(function() {
						$(this).addClass('checked');
					});
				}
			});
		});
	})(Zepto);
	
	//====================
	//购物车删除
	//====================
	(function($) {
		//删除选中商品
		$('#J_CartDeleteChoosed').click(function() {
			var father_form = $(this).parents("form");
			var checked_box = 0;
			$(".j_CartEditCheck").each(function() {
				var product_id = $(this).attr("data-id");
				var has_check = $(this).hasClass("checked");
				if (has_check) {
					checked_box++;
					var input = '<input type="hidden" name="cartids[]" value="'+ product_id +'" />';
					$(this).append(input);
				}
			});
			if ( checked_box > 0 ) {
				//确认是否删除购物车产品
				var obj_this = $(this);
				var message = '确认删除选中的' + checked_box + '个商品？';
				new Confirms(message,
					 function () {
						var url = GLOBAL.Config.base + '/cart/delete/';
						var data = obj_this.parents("form").serialize();
						var options = {
							url: url,
							type: 'post',
							data: data,
							success: function (data) {
								var url = window.location.href;
								window.location = url;
							}
						};
						$.ajax(options);
					},
					function() {
						return false;
					}
				);
			} else {
				new Tips('请选择要删除的商品');
				setTimeout(function() {
					$("#J_AppExitTipWarp").remove();
				}, 2000);
				return false;
			}
		});
	})(Zepto);
	
	//====================
	//购物车收藏
	//====================
	(function($) {
		//收藏选中商品
		$('#J_CartCollectChoosed').click(function() {
			var father_form = $(this).parents("form");
			var checked_box = 0;
			$(".j_CartEditCheck").each(function() {
				var product_id = $(this).attr("data-id");
				var has_check = $(this).hasClass("checked");
				if (has_check) {
					checked_box++;
					var input = '<input type="hidden" name="cartids[]" value="'+ product_id +'" />';
					$(this).append(input);
				}
			});
			if ( checked_box > 0 ) {
				//确认是否收藏购物车产品
				var obj_this = $(this);
				var message = '你正在收藏选中的' + checked_box + '个商品？';
				new Confirms(message,
					 function () {
						var url = GLOBAL.Config.base + '/customerwishlist/edit/';
						var data = obj_this.parents("form").serialize();
						var options = {
							url: url,
							type: 'post',
							data: data,
							success: function (data) {
								new Tips('收藏成功！');
								setTimeout(function() {
									$("#J_AppExitTipWarp").remove();
								}, 2000);
								var url = window.location.href;
								window.location = url;
							}
						}
						$.ajax(options);
					},
					function() {
						return false;
					}
				);
			} else {
				new Tips('请选择要收藏的商品');
				setTimeout(function() {
					$("#J_AppExitTipWarp").remove();
				}, 2000);
				return false;
			}
		});
	})(Zepto);
	
	//====================
	//购物车选择结算
	//====================
	(function($) {
		//单选某个产品
		$(".j_CartCheck").each(function() {
			$(this).click(function() {
				var cartid = $(this).attr("data-id");
				var has_check = $(this).hasClass("checked");
				if (has_check) {
					var checked = 1;
				} else {
					var checked = 0;
				}
				var parameters = 'cartid=' + cartid + '&checked=' + checked;
				checkbox_ajax_counts(parameters);
			});
		});
		
		/*购物车是否全选*/
		$('.j_CheckIcon').each(function() {
			$(this).click(function() {
				var checkboxs = $(this).parents('form').eq(0).find('.j_CartCheck');
				if ($('.j_CheckIcon').hasClass('checked')) {
					$('.j_CheckIcon').removeClass('checked');
					var checked = 0;
					var parameters = "checked=" + checked;
					checkboxs.each(function() {
						$(this).removeClass('checked');
						var cartid = $(this).attr("data-id");
						parameters = parameters + "&cartids[]=" + cartid;
					});
					checkbox_ajax_counts(parameters);
				} else {
					$('.j_CheckIcon').addClass('checked');
					var checked = 1;
					var parameters = "checked=" + checked;
					checkboxs.each(function() {
						$(this).addClass('checked');
						var cartid = $(this).attr("data-id");
						parameters = parameters + "&cartids[]=" + cartid;
					});
					checkbox_ajax_counts(parameters);
				}
			});
		});
		
		function checkbox_ajax_counts(parameters) {
			var url = GLOBAL.Config.base + '/cart/checked/';
			$.ajax({
				url : url,
				type : "post",
				data : parameters,
				dataType : "json",
				headers: {'X-Requested-With': 'XMLHttpRequest'},
				success: function(cart) {
					if (cart) {
						if (cart.currency == 'CNY') cart.currency = '￥ ';
						var cart_total = cart.total;
						if (cart.subtotal_all == 'NaN') cart.currency = 0 ;
						var subtotal_all = cart.currency +cart.subtotal_all;
						
						$("#J_AddCartSubtotalAll").html(cart.currency + cart.subtotal_all);
						$("#J_PaymetTotal").html(cart_total);
						//alert("总数" + cart.total);
						//alert("总价格" + cart.subtotal_all);
						
						var price_total = $("#J_AddCartSubtotalAll").text();
						if (cart.product == "" || cart_total == "0") {
							$("#J_AddCartSubtotalAll").html("￥ 0.00");
							$("#J_PaymetTotal").html("0");
							$(".j_ToCheckOut").addClass("no");
							$(".j_ToCheckOut").attr("disabled", "false");
						} else {
							$(".j_ToCheckOut").removeClass("no");
							$(".j_ToCheckOut").removeAttr("disabled");
						}
					} 
				},
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					 //alert(XMLHttpRequest.status);
					 //alert(XMLHttpRequest.readyState);
					 //alert(textStatus);
				}
			});
			
			return true;
		}
	})(Zepto);
	//====================
	//购物车编辑
	//====================
	(function($) {
		$(".j_CartEdit").click(function() {
			var obj_this = $(this);
			if ($("#J_EditBar").css("display") == 'none') {
				obj_this.text("取消");
				$("#J_PaymentBar").hide();
				$("#J_EditBar").css("display", "table");
				$(".j_CartCheckBox").each(function() {
					$(this).hide();
				});
				$(".j_EditCheck").each(function() {
					$(this).show();
				});
			} else {
				obj_this.text("编辑");
				$("#J_PaymentBar").show();
				$("#J_EditBar").hide();
				$(".j_CartCheckBox").each(function() {
					$(this).show();
				});
				$(".j_EditCheck").each(function() {
					$(this).hide();
				});
			}
		});
	})(Zepto);	
		
	//====================
	//筛选栏操作
	//====================
	(function($) {
		$("#J_FisterBtn").click(function() {
			$("#J_FilterArea").css("display", "block");
		});
		$("#J_FilterClose").click(function() {
			$("#J_FilterArea").css("display", "none");
		});
	})(Zepto);
	
	
	//====================
	//结算
	//====================
	(function($) {
		//"去结算"按钮(加入购物车并跳转到结算页)
		$(".j_CheckoutBtn").each(function() {
			$(this).click(function() {
				var aid = $(this).attr("data-aid");
				var qty = $('#J_AddCartQty-' + aid).val();
				var lancode = GLOBAL.Config.lancode;
			
				var url_add = GLOBAL.Config.base + "/cart/add/";
				var url_cart = GLOBAL.Config.base + "/cart/cartajax/";
				var url_redirect = "/cart/index/?l=" + lancode;
			
				var obj_cart = new Cart();
				obj_cart.add(url_add, url_cart, aid, qty, lancode, url_redirect);
			});
		});
		
		
		// 计算总价
		grand();
		$('#J_CheckoutShippingCustomized').change(function() { // 预付运费变动时重新计算总价
			var fee = $(this).val() ? $(this).val() : 0;
			$('#J_CheckoutShippingFee').attr('data-value', fee);
			$('#J_CheckoutShippingFee').html('+ ￥ ' + fee);
			grand();
		});
		function grand() {
			if ($('#J_CheckoutSubtotalAll')) {
				var subtotal = parseFloat($('#J_CheckoutSubtotalAll').attr('data-value'));
				if ($('#J_CheckoutShippingFee').length > 0) {
					var fee = $('#J_CheckoutShippingFee').attr('data-value');
					var grand = subtotal + parseFloat(fee);
					$('#J_CheckoutGrand').html('￥ ' + grand);
					$('#J_CheckoutGrand').parent().show();
				}
			}
		}
	})(Zepto);

	
	//====================
	//登录窗口及登录页
	//====================
	(function($) {
		function login(url, account, pwd, params, redirect) {
			if (account.length < 1 || pwd.length < 1) {
				new Tips("帐户名及密码不能为空");
				setTimeout(function() {
					$("#J_AppExitTipWarp").remove();
				}, 2000);
				return false;
			}
			
			var obj_redirect = redirect;
			var obj_url = url;
			if (params) {
				var parameters = params;
			} else {
				var parameters = {'account' : account, 'pwd' : pwd, 'redirect' : redirect};
			}
			
			var options = {
				url: obj_url,
				type: 'post',
				data: parameters,
				headers: {'X-Requested-With': 'XMLHttpRequest'},
				success: function (transport) {
					if (transport != 'error' ) {
						if (obj_url == GLOBAL.Config.base + '/customer/login/?l=' + GLOBAL.Config.lancode || 
								obj_url == obj_redirect) {
							if (transport.errors != undefined) {
								if (transport.errors['login_error']) {
									$("#J_Errors-loginError").text("错误：很抱歉，您输入的帐户名或密码有误");
								}
								if (transport.errors['fixed']) {
									$("#J_Errors-loginError").text("该账号您已经关联过！");
								}
							} else {
								//更新自动登录信息
								if ($("#J_LoginWinIsAuto").is(':checked')) {
									storage_save();
								}
								
								if ($("#J_LoginForm").attr('data-redirect-pre')) {
									var url = './template.html?';
									url += 'controller=' + transport.redirect.controller;
									url += '&action=' + transport.redirect.action;
									url += '&' + transport.redirect.params;
									window.location = url;
								} else {
									window.location = transport.redirect.url;
								}
							}
						} else {
							//更新自动登录信息
							if ($("#J_LoginWinIsAuto").is(':checked')) {
								storage_save();
							} else {
								storage_clean(true);
							}
							
							//更新全局标识
							$("body").find("header").attr("data-islogin", "true");
						
							//更新会员信息
							var url_identity = GLOBAL.Config.base + "/customer/identityajax/";

							new Identity(url_identity, '#J_IdentityYes', '#J_IdentityNo', '#J_IdentityName');
							
							//关闭窗口
							$('#J_LoginWin').hide();
						
							//如果是加入购物车时触发了登录窗口，则成功后执行加入购物车
							var aid = $('#J_LoginWinProductAid').val();
							if (aid) {
								var url_add = GLOBAL.Config.base + "/cart/add/";
								var url_cart = GLOBAL.Config.base + "/cart/cartajax/";

								var qty = $('#J_AddCartQty-' + aid).val();
								var lancode = GLOBAL.Config.lancode;
								var redirect = $('#J_LoginWinRedirect').val();
							
								var obj_cart = new Cart();
								obj_cart.add(url_add, url_cart, aid, qty, lancode, redirect);
							} else {
								//关闭窗口
								$('#J_ThickDiv').hide();
							}
						}
					} else {
						new Tips("帐户名或密码有误");
						setTimeout(function() {
							$("#J_AppExitTipWarp").remove();
						}, 2000);
					}
				}
			};
			$.ajax(options);
			return false;
		}
	
	
		//获取自动登录信息
		function storage_get() {
			try {
				var o = window.localStorage;
				if (o.account != undefined && o.pwd != undefined && o.isAuto != undefined) {
					return o;
				} else {
					return false;
				}
			} catch (e) {
				//忽略错误
			}
		}
	
		//保存自动登录信息
		function storage_save() {
			try {
				var o = window.localStorage;
				o.account = $('#J_LoginWinInputAccount').val();
				o.pwd = $('#J_LoginWinInputPwd').val();
				o.isAuto = true;
			} catch (e) {
				//忽略错误
			}
		}
	
		//清除自动登录信息
		function storage_clean(is_change_auto) {
			try {
				var o = window.localStorage;
				o.account = '';
				o.pwd = '';
				if (is_change_auto) {
					o.isAuto = false;
				}
			} catch (e) {
				//忽略错误
			}
		}
	
		$("#J_LoginWinClose").click(function() {
			$('#J_ThickDiv').hide();
			$('#J_LoginWin').hide();
			return false;
		});
	
		$("#J_LoginWinInputPwd").keydown(function(e) {
			if (e.keyCode == 13) {
				$("#J_LoginWinBtnLogin").click();
			}
		});
	
		$(".j_LoginWinInput input").each(function() {
			$(this).focusin(function() {
				$(this).addClass('hightlight');
			});
			$(this).focusout(function() {
				$(this).removeClass('hightlight');
			});
		});
	
		$("#J_LoginWinBtnLogin").click(function() {
			var account = $('#J_LoginWinInputAccount').val();
			var pwd = $('#J_LoginWinInputPwd').val();
			var url = GLOBAL.Config.base + '/cart/loginajax';
			login(url, account, pwd);
		});
	
	
		////登录页部分

		/*登录显隐密码切换*/
		$('#J_LoginTooglePwd').click(function() {
			var textInput = $(this).siblings(".plaintext");
			var pwdInput = $(this).siblings(".ciphertext");
			if ($(this).hasClass("btn-off")) {
				$(this).addClass("btn-on");
				$(this).removeClass("btn-off");
				$("#J_LoginWinInputPwd").attr('type','text');
			} else {
				$(this).removeClass("btn-on");
				$(this).addClass("btn-off");
				$("#J_LoginWinInputPwd").attr('type','password');
			}
		});
		
		//点击清空内容
		$("#J_LoginInputClean").click(function() {
			$('#J_LoginWinInputAccount').val(" ");
		});
		
		$('#J_LoginForm').submit(function() {
			var account = $('#J_LoginWinInputAccount').val();
			var pwd = $('#J_LoginWinInputPwd').val();
			var redirect = $("#J_LoginFormRedirect").val();
			var url = GLOBAL.Config.base + $(this).attr("action");
			var params = $(this).serialize();
			login(url, account, pwd, params, redirect);
			return false;
		});
	
	
		////自动登录部分
		//在logout页清除登录信息(注意本段代码要放在自动登录的前面)
		if ($("#J_LableLogout").length) {
			storage_clean();
		}
		
		var islogin = $("body").find("header").attr("data-islogin");
		if (islogin == 'false') {
			islogin = false;
		} else {
			islogin = true;
		}
		
		//自动登录
		if (! islogin) {
			var o = storage_get();
			if (o && o.account && o.pwd) {
				var url = GLOBAL.Config.base + '/cart/loginajax';
				login(url, o.account, o.pwd);
			}
		
			//如果上次登录时没勾选自动登录，则默认不勾选
			if ($("#J_LoginWinIsAuto").length) {
				if (o && o.isAuto == 'false') {
					$("#J_LoginWinIsAuto").removeAttr('checked');
				}
			}
		}
	})(Zepto);
	
	
	//====================
	//注册验证码
	//====================
	(function($) {
		// Captcha
		var bind_name_captcha = 'input';
		if (navigator.userAgent.indexOf("MSIE") != -1){
			bind_name_captcha = 'propertychange';
		}
		$('#J_RegisterCaptcha').bind(bind_name_captcha, function() {
			var obj = $(this);
			
			// 注意Zepto-validation会在input加上validation-warning，清除提示信息时需作限定div.validation-warning
			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			obj.attr('data-isvalid', 0);
			
			var url = GLOBAL.Config.base + '/customer/captcha/';
			var code = obj.val();
			if (code.length == 5) {
				var parameters = {'code' : code, 'type': 'register'};
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result == '1') {
							obj.attr('data-isvalid', 1);
							str = $('<div class="validation-passed">验证通过</div>');
						} else {
							str = $('<div class="validation-warning">验证码错误</div>');
						}
						//str.insertAfter(obj);
						obj.parent().append(str);
					}
				});
			}
		});
		$('#J_RegisterCaptchaImg').click(function() {
			this.src= GLOBAL.Config.base + '/customer/captcha/?type=register&d=' + Math.random();
		});
		
		// Smscode
		var bind_name_smscode = 'input';
		if (navigator.userAgent.indexOf("MSIE") != -1){
			bind_name_smscode = 'propertychange';
		}
		$('#J_RegisterSmscode').bind(bind_name_smscode, function() {
			var obj = $(this);

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var url = GLOBAL.Config.base + '/customer/smscode/';
			var code = obj.val();
			if (code.length == 6) {
				var parameters = {'code': code, 'type': 'register'};
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result == '1') {
							str = $('<div class="validation-passed">短信验证通过</div>');
						} else {
							str = $('<div class="validation-warning">短信验证码错误</div>');
						}
						//str.insertAfter(obj);
						obj.parent().append(str);
					}
				});
			}
		});
		
		var wait = 60;
		function time_smscode(o) {
			o = $(o);
			if (wait == 0) {
				o.removeClass('disabled');
				o.text('获取短信验证码');
				wait = 60;
			} else {
				o.addClass('disabled');
				o.text('重新发送(' + wait + ')');
				wait--;
				setTimeout(function() {
					time_smscode(o);
				}, 1000);
			}
		}
		function check_mobile(obj) {
			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var mobile = $('#J_RegisterMobile').val();
			if (! (/^1[3|4|5|8][0-9]\d{8}$/.test(mobile))) {
				var str = $('<div class="validation-warning">请输入正确的手机号码</div>');
				obj.parent().append(str);
				
				return false;
			} else {
				return true;
			}
		}
		function check_captcha(obj) {
			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var is_valid = parseInt($('#J_RegisterCaptcha').attr('data-isvalid'));
			if (! is_valid) {
				var str = $('<div class="validation-warning">请输入正确的验证码</div>');
				obj.parent().append(str);
				
				return false;
			} else {
				return true;
			}
		}
		function reset_smscode() {
			var obj = $('#J_RegisterSmscode');
			obj.val('');

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
		}
		$('#J_RegisterSmscodeSend').click(function() {
			var obj = $(this);
			if (! obj.hasClass('disabled')) {
				obj.parent().find('div.validation-passed').remove();
				obj.parent().find('div.validation-warning').remove();
				
				// 检验手机号及验证码
				if (check_mobile(obj) && check_captcha(obj)) {
					var mobile = $('#J_RegisterMobile').val();
					var parameters = {'mobile': mobile, 'type': 'register'};
					var url = GLOBAL.Config.base + '/customer/smscode/';
					$.ajax({
						url : url,
						type : "get",
						data : parameters,
						dataType : "json",
						headers: {'X-Requested-With': 'XMLHttpRequest'},
						success: function(result) {
							var str;
							if (result.code == '0') {
								str = $('<div class="validation-passed">短信验证码发送成功</div>');
							} else {
								str = $('<div class="validation-warning">' + result.msg + '</div>');
							}
							obj.parent().append(str);
						}
					});
				} else {
					return false;
				}
				
				time_smscode(obj);
				reset_smscode();
			}
		});
	})(Zepto);
	
	
	//====================
	//找回密码验证码
	//====================
	(function($) {
		// Captcha
		var bind_name_captcha = 'input';
		if (navigator.userAgent.indexOf("MSIE") != -1){
			bind_name_captcha = 'propertychange';
		}
		$('#J_FetchpasswordCaptcha').bind(bind_name_captcha, function() {
			var obj = $(this);
			
			// 注意Zepto-validation会在input加上validation-warning，清除提示信息时需作限定div.validation-warning
			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var url = GLOBAL.Config.base + '/customer/captcha/';
			var code = obj.val();
			if (code.length == 5) {
				var parameters = {'code' : code, 'type': 'fetchpassword'};
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result == '1') {
							str = $('<div class="validation-passed">验证通过</div>');
						} else {
							str = $('<div class="validation-warning">验证码错误</div>');
						}
						obj.parent().append(str);
					}
				});
			}
		});
		$('#J_FetchpasswordCaptchaImg').click(function() {
			this.src= GLOBAL.Config.base + '/customer/captcha/?type=fetchpassword&d=' + Math.random();
		});
		
		// Smscode
		var bind_name_smscode = 'input';
		if (navigator.userAgent.indexOf("MSIE") != -1){
			bind_name_smscode = 'propertychange';
		}
		$('#J_FetchpasswordSmscode').bind(bind_name_smscode, function() {
			var obj = $(this);

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var url = GLOBAL.Config.base + '/customer/smscode/';
			var code = obj.val();
			if (code.length == 6) {
				var parameters = {'code': code, 'type': 'fetchpassword'};
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result == '1') {
							str = $('<div class="validation-passed">短信验证通过</div>');
						} else {
							str = $('<div class="validation-warning">短信验证码错误</div>');
						}
						obj.parent().append(str);
					}
				});
			}
		});
		
		var wait = 60;
		function time_smscode(o) {
			o = $(o);
			if (wait == 0) {
				o.removeClass('disabled');
				o.text('获取短信验证码');
				wait = 60;
			} else {
				o.addClass('disabled');
				o.text('重新发送(' + wait + ')');
				wait--;
				setTimeout(function() {
					time_smscode(o);
				}, 1000);
			}
		}
		function reset_smscode() {
			var obj = $('#J_FetchpasswordSmscode');
			obj.val('');

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
		}
		$('#J_FetchpasswordSmscodeSend').click(function() {
			var obj = $(this);
			if (! obj.hasClass('disabled')) {
				obj.parent().find('div.validation-passed').remove();
				obj.parent().find('div.validation-warning').remove();
				
				var parameters = {'type': 'fetchpassword'};
				var url = GLOBAL.Config.base + '/customer/smscode/';
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					dataType : "json",
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result.code == '0') {
							str = $('<div class="validation-passed">短信验证码发送成功</div>');
						} else {
							str = $('<div class="validation-warning">' + result.msg + '</div>');
						}
						obj.parent().append(str);
					}
				});
				
				time_smscode(obj);
				reset_smscode();
			}
		});
		
		// Mailcode
		var bind_name_mailcode = 'input';
		if (navigator.userAgent.indexOf("MSIE") != -1){
			bind_name_mailcode = 'propertychange';
		}
		$('#J_FetchpasswordMailcode').bind(bind_name_mailcode, function() {
			var obj = $(this);

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var url = GLOBAL.Config.base + '/customer/mailcode/';
			var code = obj.val();
			if (code.length == 6) {
				var parameters = {'code': code, 'type': 'fetchpassword'};
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result == '1') {
							str = $('<div class="validation-passed">邮箱验证通过</div>');
						} else {
							str = $('<div class="validation-warning">邮件验证码错误</div>');
						}
						obj.parent().append(str);
					}
				});
			}
		});
		
		var wait = 60;
		function time_mailcode(o) {
			o = $(o);
			if (wait == 0) {
				o.removeClass('disabled');
				o.text('获取邮件验证码');
				wait = 60;
			} else {
				o.addClass('disabled');
				o.text('重新发送(' + wait + ')');
				wait--;
				setTimeout(function() {
					time_mailcode(o);
				}, 1000);
			}
		}
		function reset_mailcode() {
			var obj = $('#J_FetchpasswordMailcode');
			obj.val('');

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
		}
		$('#J_FetchpasswordMailcodeSend').click(function() {
			var obj = $(this);
			if (! obj.hasClass('disabled')) {
				obj.parent().find('div.validation-passed').remove();
				obj.parent().find('div.validation-warning').remove();
				
				var parameters = {'type': 'fetchpassword'};
				var url = GLOBAL.Config.base + '/customer/mailcode/';
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					dataType : "json",
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result.code == '0') {
							str = $('<div class="validation-passed">邮件验证码发送成功</div>');
						} else {
							str = $('<div class="validation-warning">' + result.msg + '</div>');
						}
						obj.parent().append(str);
					}
				});
				
				time_mailcode(obj);
				reset_mailcode();
			}
		});
		
		$('#J_FetchpasswordVerifytype').change(function() {
			if ($(this).val() == 'mobile') {
				$('#J_FetchpasswordSms').show();
				$('#J_FetchpasswordMail').hide();
			} else if ($(this).val() == 'email') {
				$('#J_FetchpasswordSms').hide();
				$('#J_FetchpasswordMail').show();
			}
		});
		if ($('#J_FetchpasswordVerifytype').val() == 'mobile') {
			$('#J_FetchpasswordSms').show();
			$('#J_FetchpasswordMail').hide();
		} else if ($('#J_FetchpasswordVerifytype').val() == 'email') {
			$('#J_FetchpasswordSms').hide();
			$('#J_FetchpasswordMail').show();
		}
	})(Zepto);
	
	
	//====================
	//帐户中心验证码
	//====================
	(function($) {
		// Smscode
		var bind_name_smscode = 'input';
		if (navigator.userAgent.indexOf("MSIE") != -1){
			bind_name_smscode = 'propertychange';
		}
		$('#J_AccountSmscode').bind(bind_name_smscode, function() {
			var obj = $(this);
			
			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var url = GLOBAL.Config.base + '/customer/smscode/';
			var code = obj.val();
			if (code.length == 6) {
				var parameters = {'code': code, 'type': 'account'};
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result == '1') {
							str = $('<div class="validation-passed">短信验证通过</div>');
						} else {
							str = $('<div class="validation-warning">短信验证码错误</div>');
						}
						obj.parent().append(str);
					}
				});
			}
		});
		
		var wait = 60;
		function time_smscode(o) {
			o = $(o);
			if (wait == 0) {
				o.removeClass('disabled');
				o.text('获取短信验证码');
				wait = 60;
			} else {
				o.addClass('disabled');
				o.text('重新发送(' + wait + ')');
				wait--;
				setTimeout(function() {
					time_smscode(o);
				}, 1000);
			}
		}
		function check_mobile(obj) {
			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var mobile = $('#J_AccountMobile').val();
			if (! (/^1[3|4|5|8][0-9]\d{8}$/.test(mobile))) {
				var str = $('<div class="validation-warning">请输入正确的手机号码</div>');
				obj.parent().append(str);
				
				return false;
			} else {
				return true;
			}
		}
		function reset_smscode() {
			var obj = $('#J_AccountSmscode');
			obj.val('');

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
		}
		$('#J_AccountSmscodeSend').click(function() {
			var obj = $(this);
			if (! obj.hasClass('disabled')) {
				obj.parent().find('div.validation-passed').remove();
				obj.parent().find('div.validation-warning').remove();
				
				// 检验手机号
				if (check_mobile(obj)) {
					var mobile = $('#J_AccountMobile').val();
					var parameters = {'mobile': mobile, 'type': 'account'};
					var url = GLOBAL.Config.base + '/customer/smscode/';
					$.ajax({
						url : url,
						type : "get",
						data : parameters,
						dataType : "json",
						headers: {'X-Requested-With': 'XMLHttpRequest'},
						success: function(result) {
							var str;
							if (result.code == '0') {
								str = $('<div class="validation-passed">短信验证码发送成功</div>');
							} else {
								str = $('<div class="validation-warning">' + result.msg + '</div>');
							}
							obj.parent().append(str);
						}
					});
				} else {
					return false;
				}
				
				time_smscode(obj);
				reset_smscode();
			}
		});
		
		// Mailcode
		var bind_name_mailcode = 'input';
		if (navigator.userAgent.indexOf("MSIE") != -1){
			bind_name_mailcode = 'propertychange';
		}
		$('#J_AccountMailcode').bind(bind_name_mailcode, function() {
			var obj = $(this);

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var url = GLOBAL.Config.base + '/customer/mailcode/';
			var code = obj.val();
			if (code.length == 6) {
				var parameters = {'code': code, 'type': 'account'};
				$.ajax({
					url : url,
					type : "get",
					data : parameters,
					headers: {'X-Requested-With': 'XMLHttpRequest'},
					success: function(result) {
						var str;
						if (result == '1') {
							str = $('<div class="validation-passed">邮箱验证通过</div>');
						} else {
							str = $('<div class="validation-warning">邮件验证码错误</div>');
						}
						obj.parent().append(str);
					}
				});
			}
		});
		
		var wait = 60;
		function time_mailcode(o) {
			o = $(o);
			if (wait == 0) {
				o.removeClass('disabled');
				o.text('获取邮件验证码');
				wait = 60;
			} else {
				o.addClass('disabled');
				o.text('重新发送(' + wait + ')');
				wait--;
				setTimeout(function() {
					time_mailcode(o);
				}, 1000);
			}
		}
		function check_email(obj) {
			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
			
			var email = $('#J_AccountEmail').val();
			if (! (/^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-])+/.test(email))) {
				var str = $('<div class="validation-warning">请输入正确的邮箱</div>');
				obj.parent().append(str);
				
				return false;
			} else {
				return true;
			}
		}
		function reset_mailcode() {
			var obj = $('#J_AccountMailcode');
			obj.val('');

			obj.parent().find('div.validation-passed').remove();
			obj.parent().find('div.validation-warning').remove();
		}
		$('#J_AccountMailcodeSend').click(function() {
			var obj = $(this);
			if (! obj.hasClass('disabled')) {
				obj.parent().find('div.validation-passed').remove();
				obj.parent().find('div.validation-warning').remove();
				
				// 检验手机号
				if (check_email(obj)) {
					var email = $('#J_AccountEmail').val();
					var parameters = {'email': email, 'type': 'account'};
					var url = GLOBAL.Config.base + '/customer/mailcode/';
					$.ajax({
						url : url,
						type : "get",
						data : parameters,
						dataType : "json",
						headers: {'X-Requested-With': 'XMLHttpRequest'},
						success: function(result) {
							var str;
							if (result.code == '0') {
								str = $('<div class="validation-passed">邮件验证码发送成功</div>');
							} else {
								str = $('<div class="validation-warning">' + result.msg + '</div>');
							}
							obj.parent().append(str);
						}
					});
				} else {
					return false;
				}
				
				time_mailcode(obj);
				reset_mailcode();
			}
		});
	})(Zepto);
});

//============================
//搜索历史保存在localStorage中
//============================
Zepto(function($){
	
	// 去除数组重复方法
	// 参考网址：http://blog.csdn.net/chengxuyuan20100425/article/details/8497277
	// 此方法只是操作数组，localstorage中依然存在重复部分
	function unique(arr) {
		var n = {}, r = [], len = arr.length, val, type;
		for (var i = 0; i < arr.length; i++) {
			val = arr[i];
			type = typeof val;
			if (!n[val]) {
				n[val] = [type];
				r.push(val);
			} else if (n[val].indexOf(type) < 0) {
				n[val].push(type);
				r.push(val);
			}
		}
		arr = r;
		return arr;
	}

	function append_history(obj) {
		var o = get_history();
		$(obj).html("");
		var search = o.search;

		if (search != undefined && search != "") {
			var arr = search.split(',');

			// 数组去除重复部分
			arr = unique(arr);
			
			// 解除数组组合
			arr = arr.join();
			arr = arr.split(',');

			var search_list = " ";
			
			// 获取本站地址
			var url;
			if ($('#J_InfoSearch').attr('data-redirect-pre')) {
				url = './template.html?controller=search&action=index&l=zh-CN&q=';
			} else {
				url = '/search/?l=zh-CN&q=';
			}

			// 循环数组部分
			for (var i = 0; i < arr.length; i++) {
				if (arr[i] != '') {
					search_list += '<li><a href="' + url + arr[i] + ' ">' + arr[i] + '</a></li>';
				}
			}
			// 把循环内容放进搜索历史页面中
			$('#J_InfoSearch').html(search_list);
		} else {
			var search_list = " ";
			search_list += '<li>暂无历史记录</li>';
			$('#J_InfoSearch').html(search_list);
		}
	}

	function get_history() {
		try {
			var o = window.localStorage;
			if (o.search != undefined) {
				return o;
			} else {
				return false;
			}
		} catch (e) {
			// 忽略错误
		}
	}

	function set_history() {
		try {
			var o = window.localStorage;
			var search = [];
			var arrhistory = o.search;
			// 把localstorage读出来，放进数组中
			if (arrhistory != '') {
				search.push(arrhistory);
			}

			var search_val = $('.j_searchkey').val();

			// 每次操作将搜索的值放入数组中(从头部插入)
			if (search_val != '') {
				search.unshift(search_val);
			// 将数组放到localstorage中
				o.search = search;
			}
			
		} catch (e) {
			// 忽略错误
		}
	}

	function clear_history() {
		try {
			var o = window.localStorage;
			o.search = '';
			$('#J_InfoSearch').find('li').remove();
		} catch (e) {
			// 忽略错误
		}
	}
	
	// 页面一开始就加载localstorage(判断页面中是否有搜索表单)
	$('body').find('.j_form').each(function() {
		append_history();
	});
	
	// 搜索提交时开始记录
	$('.j_SearchHistoryBtn').click(function(e) {
		set_history();
		append_history();
	});
	
	// 清除历史保存
	$('#J_HistoryClear').click(function() {
		clear_history();
	});
});

//============================
//app中login_faild调用
//============================
Zepto(function($){
	if ($("#J_Location").length > 0) {
		var url = $("#J_Location").attr("data-location");
		window.location.href = url;
	}
});

Zepto(function($){
//=============================
//搜索推荐关键字，放在全局供回调函数使用
//=============================
	if (Zepto("#J_KeywordSug").length > 0) {
		var ObjKeywordSug = new KeywordSuggestion(GLOBAL.Config.base + '/search/tagajax', '#J_KeywordSug', "#J_SearchQ");
	}
});
//=============================
//国家列表获取，放在全局供回调函数使用(只统一js用m版实际代码在该页面)
//=============================
if (Zepto("#J_CountryCncode").length > 0) {
	var chain = Zepto("#J_Chain").attr("data-value").split(",");
	var objSelectCountryRegion = new SetSelectCountryRegionCustomer(
		GLOBAL.Config.base,
		"J_CountryCncode",
		"J_CountryCity",
		".j_CountryCity",
		"objSelectCountryRegion",
		chain
	);
	objSelectCountryRegion.getData(Zepto("#J_CountryCncode"));
}