/**
 * $.float
 * @extends jquery.1.4
 * @fileOverview 创建一个悬浮层，支持上、下、左、右、右中、左中浮动
 * @author 明河共影
 * @email mohaiguyan12@126.com
 * @version 0.1
 * @date 2010-04-18
 * Copyright (c) 2010-2010 明河共影
 * @example
 *	$("#to-right").float({position:"rm"}); //右中位置浮动
 */
(function($) {
	$.fn.float = function(settings) {
		if (typeof settings == "object") {
			settings = $.extend({
				//延迟
				delay: 1000,
				//位置偏移
				offset: {
					left: 0,
					right: 0,
					top: 0,
					bottom: 0
	
				},
				style: null,
				//样式
				width: 100,
				//宽度
				height: 200,
				//高度
				position: "rm"
				//位置
	
			},
			settings || {});
			var winW = $(window).width();
			var winH = $(window).height();
	
			//根据参数获取位置数值
			function getPosition($applyTo, position) {
				var _pos = null;
				switch (position) {
					case "rm":
					$applyTo.data("offset", "right");
					$applyTo.data("offsetPostion", settings.offset.right);
					_pos = {
						right: settings.offset.right,
						top: winH / 2 - $applyTo.innerHeight() / 2
					};
					break;
					case "lm":
					$applyTo.data("offset", "left");
					$applyTo.data("offsetPostion", settings.offset.left);
					_pos = {
						left: settings.offset.left,
						top: winH / 2 - $applyTo.innerHeight() / 2
					};
					break;
					case "rb":
					_pos = {
						right: settings.offset.right,
						top: winH - $applyTo.innerHeight()
					};
					break;
					case "lb":
					_pos = {
						left: settings.offset.left,
						top: winH - $applyTo.innerHeight()
					};
					break;
					case "l":
					_pos = {
						left: settings.offset.left,
						top: settings.offset.top
					};
					break;
					case "r":
					_pos = {
						right: settings.offset.right,
						top: settings.offset.top
					};
					break;
					case "t":
					$applyTo.data("offset", "top");
					$applyTo.data("offsetPostion", settings.offset.top);
					_pos = {
						left: settings.offset.left,
						top: settings.offset.top
					};
					break;
					case "b":
					$applyTo.data("offset", "bottom");
					$applyTo.data("offsetPostion", settings.offset.bottom);
					_pos = {
						left: settings.offset.left,
						top: winH - $applyTo.innerHeight()
					};
					break;
	
				}
				return _pos;
	
			}
			//设置容器位置
			function setPosition($applyTo, position, isUseAnimate) {
				var scrollTop = $(window).scrollTop();
				var scrollLeft = $(window).scrollLeft();
				var _pos = getPosition($applyTo, position);
				_pos.top += scrollTop;
				isUseAnimate && $applyTo.stop().animate(_pos, settings.delay) || $applyTo.css(_pos);
	
			}
			return this.each(function() {
				var $this = $(this);
				$this.css("position", "absolute");
				settings.style && $this.css(settings.style);
				setPosition($this, settings.position);
				$(this).data("isAllowScroll", true);
				$(window).scroll(function() {
					$this.data("isAllowScroll") && setPosition($this, settings.position, true);
	
				});
	
			})
	
		} else {
			var speed = arguments.length > 1 && arguments[1] || "fast";
			this.each(function() {
				if (settings == "clearOffset") {
					var _c = {};
					if ($(this).data("offset")) {
						_c[$(this).data("offset")] = 0;
						$(this).data("isAllowScroll", false);
						$(this).stop().animate(_c, speed);
	
					}
	
				} else if (settings == "addOffset") {
					var _c = {};
					if ($(this).data("offset") && $(this).data("offsetPostion")) {
						_c[$(this).data("offset")] = $(this).data("offsetPostion");
						$(this).stop().animate(_c, speed);
						$(this).data("isAllowScroll", true);
	
					}
	
	
				} else if (settings == "setScrollDisable") {
					$(this).data("isAllowScroll", false);
	
				} else if (settings == "setScrollUsable") {
					$(this).data("isAllowScroll", true);
	
				}
	
			})
	
		}
	
	}
})(Zepto);


window.onload = function() {
	Zepto("#to-right").float({
		position: "rm"
	});
	var returnTop = Zepto('#goTop-box');

	Zepto(window).scroll(function() {

		if (Zepto(this).scrollTop() > 400) {
			returnTop.show();

		} else {
			returnTop.hide();

		}

	});

}
function showClose() {
	Zepto('#close').toggle();

}
function closeRight() {
	Zepto("#to-right").hide();
}

/* 
 * jquery.scrollLoading.js 
 * by zhangxinxu  http://www.zhangxinxu.com 
 * 2010-11-19 v1.0 
 * http://blog.csdn.net/ajun_studio/article/details/6728358
*/
(function($) {
	$.fn.scrollLoading = function(options) {
		var defaults = {
			attr: "data-url"

		};
		var params = $.extend({},
		defaults, options || {});
		params.cache = [];
		$(this).each(function() {
			var node = this.nodeName.toLowerCase(),
			url = $(this).attr(params["attr"]);
			if (!url) {
				return;
			}
			//重组  
			var data = {
				obj: $(this),
				tag: node,
				url: url

			};
			params.cache.push(data);

		});
		//动态显示数据  
		var loading = function() {
			var st = $(window).scrollTop(),
			sth = st + $(window).height();
			$.each(params.cache, 
			function(i, data) {
				var o = data.obj,
				tag = data.tag,
				url = data.url;
				var url_load = GLOBAL.Config.imgPath + '/loading.gif';
				var url_noimg = GLOBAL.Config.imgPath + '/nopic_s.gif';
				if (o) {
					post = o.position().top;
					post = o.offset().top;
					posb = post + o.height();

					if ((post > st && post < sth) || (posb > st && posb < sth)) {
						//在浏览器窗口内  
						if (tag === "img") {
							//图片，改变src  
							o.attr("src", url_load);
							var width = o.attr("width") ? o.attr("width") : 0;
							var height = o.attr("height") ? o.attr("height") : 0;
							o.attr("height", 20)
							o.attr("width", 20);
							var img = new Image();
							img.src = url;
							if (img.complete) {
								o.attr("src", url);
								if (height != 0) {
									o.attr("height", height);

								} else {
									o.removeAttr("height");

								}
								if (width != 0) {
									o.attr("width", width);

								} else {
									o.removeAttr("width");

								}

							} else {
								img.onload = function() {
									o.attr("src", url);
									if (height != 0) {
										o.attr("height", height);

									} else {
										o.removeAttr("height");

									}
									if (width != 0) {
										o.attr("width", width);

									} else {
										o.removeAttr("width");
									}

								};
								img.onerror = function() {
									//加载图片错误
									o.attr("src", url_noimg);
									if (height != 0) {
										o.attr("height", height);

									} else {
										o.removeAttr("height");

									}
									if (width != 0) {
										o.attr("width", width);

									} else {
										o.removeAttr("width");

									}

								};

							}

						} else if (tag == "iframe") {
							o.attr("src", url);

						} else if (tag == "span") {
							eval(url);

						}
						else {
							o.load(url);

						}
						data.obj = null;

					}

				}

			});
			return false;

		};

		//事件触发  
		//加载完毕即执行  
		loading();

		//滚动执行  
		$(window).scroll(function() {
			loading();
		})

	};

})(Zepto);

Zepto(function() {
	Zepto(".on_scroll_load_img").scrollLoading();
});