Zepto(function($) {
	// 公共接口地址
	var api_url = 'http://api.nanguo.cn/wechat/scanqrcode/';
	var api_url_location = 'http://api.nanguo.cn/wechat/openlocation/';
	
	// 设置地图全局距离后调出路线,场外x公里定义（一公里）
	var x_distance = 1000;
	
	// 不跳转登录添加例外[controller, action]
	var array_model = new Array(
		['contact', 'map']
	);
	
	// 跳转到api执行扫码
	function scanQRCode(domain, url) {
		// 获取当前的url
		var back_url = escape(window.location.href);
		var scan_url = escape(domain + url);
		var location_url = api_url + '?back_url=' + back_url + '&scan_url=' + scan_url;
		window.location = location_url;
	}
	
	// 点击获取路线
	function mapWay() {
		$('.j_MapCompanyList').each(function() {
			var list_this = $(this);
			// 判断当前位置距离店铺长度
			var distance = list_this.attr("data-distance");
			// 大于1公里后执行调用外部驾车导航
			if (1 || distance > x_distance) {
				$(this).find(".j_MapCompanyLocation").unbind("click").click(function() {
					getMapWay(list_this);
				});
			}
		});
	}
	
	// 自动获取路线
	function companyMapWay() {
		$('.j_MapCompanyList').each(function() {
			var list_this = $(this);
			getMapWay(list_this);
		});
	}
	
	// 获取路线
	function getMapWay(list_this) {
		//  终点坐标获取
		var bmapx = list_this.attr("data-bmapx"); // 百度经度
		var bmapy = list_this.attr("data-bmapy"); // 百度纬度
		// 店铺信息
		var company_name = list_this.find(".j_CompanyName").text();
		var company_address = list_this.find(".j_CompanyAddress").text();
		// 转换坐标
		var point = BdmapEncryptToMapabc(bmapy, bmapx);
		var wechat_lng = point.lng; // 腾讯经度
		var wechat_lat = point.lat; // 腾讯纬度
		// 返回连接为首页
		var back_url = escape($("#J_MapCompanyBox").attr("data-domain"));
		// 跳转api调用微信地图(路径传输中文要进行两次escape不然ios提示签名错误)
		var location_url = api_url_location + '?back_url=' +
				back_url + '&wechatlng=' + wechat_lng + '&wechatlat=' + wechat_lat  + '&company_name=' + 
				escape(escape(company_name)) + '&company_address=' + escape(escape(company_address));
		window.location = location_url;
	}
	
	// 百度地图坐标转换腾讯地图坐标
	function BdmapEncryptToMapabc(bd_lat,bd_lon) {
		var point = {};
		var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
		var x = new Number(bd_lon - 0.0065);  
		var y = new Number(bd_lat - 0.006);  
		var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * x_pi);  
		var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * x_pi);  
		var Mars_lon = z * Math.cos(theta);  
		var Mars_lat = z * Math.sin(theta);  
		point.lng = Mars_lon;  
		point.lat = Mars_lat;  
		return point;
	}
	
	var browser = {
		versions: function () {
			var u = navigator.userAgent, app = navigator.appVersion;
			return { //移动终端浏览器版本信息
				weixin: u.indexOf('MicroMessenger') > -1 //是否微信
			};
		}()
	};
	
	// 判断浏览器是否微信环境&&需要扫码
	if (browser.versions.weixin) {
		if ($(".j_SearchScan").length > 0 || $("#J_OrderScan").length > 0 ||
					$(".j_CountProduct").length > 0) {
			// 关闭首页的分类
			$(".indexSearch-icon_Leibie").css("display", "none");
			
			// 关闭悬浮栏的分类
			$(".indexbottomNav-catalogproduct-a").css("display", "none");
			
			// 扫码按钮显现
			$(".j_SearchScan").each(function() {
				$(this).css('display', 'inline-block');
			});
			$("#J_OrderScan").css('display', 'inline-block');
			
			// 扫码搜索产品列表
			$(".j_SearchScan").each(function() {
				$(this).click(function() {
					var url = GLOBAL.Config.base +'/search/?q=';
					// 当前域名获取
					var domain = $(this).attr("data-domain");
					scanQRCode(domain, url);
				});
			}); // end_Searchscan
			
			// 模拟扫码点货
			if ($(".j_CountProduct").length > 0) {
				//判断params中含有scan=true
				var path_params = window.location.search;
				var params_scan = path_params.indexOf("&scan=true");
				if (params_scan != "-1") {
					$(".j_CountProduct").trigger("click");
				}
			}
			
			//点击订单扫码
			$("#J_OrderScan").click(function() {
				$(this).parents("form").find(".j_SearchType").val("barcode");
				var action = $(this).parents("form").attr("action");
				var params = $(this).parents("form").serialize();
				var re_params = params.substring(params.indexOf('&q=') + 1, params.length);
				params = params.replace(re_params, "");
				var url = action + "?" + params + "scan=true&q=";
				// 当前域名获取
				var domain = $(this).attr("data-domain");
				scanQRCode(domain, url);
			});
			
			// 新增点订单点货扫码
			if ($("#J_CountResult").length > 0) {
				var add_button = "<button id='J_CountScan'>扫码点货</button>";
				var button_parent = $("#J_CountResult").parent();
				var icon_scan = "<span id='J_CountScanIcon'><img width='12px' height='12px'" +
						" src='/skin/m/img/customer/icon_countscan.png' /></span>";
				button_parent.prepend(add_button);
				button_parent.find("button").each(function() {
					$(this).css("width", "50%");
				});
				$("#J_CountScan").prepend(icon_scan);
				$("#J_CountScanIcon").css("margin-right", "3px");
				
				$("#J_CountScan").click(function() {
					$("#J_OrderScan").parents("form").find(".j_SearchType").val("barcode");
					var action = $("#J_OrderScan").parents("form").attr("action");
					var params = $("#J_OrderScan").parents("form").serialize();
					var re_params = params.substring(params.indexOf('&q=') + 1, params.length);
					params = params.replace(re_params, "");
					var search_url = action + '?' + params + "scan=true&q=";
					// 当前域名获取
					var domain = $("#J_OrderScan").attr("data-domain");
					scanQRCode(domain, search_url);
				});
			}
		}
		
		// 微信导航地图
		if ($("#J_MapCompanyBox").length > 0) {
			$("#J_MapCompanyBox").attr("data-iswechat", "true"); // 设置全局微信环境
			// 等待所有事件加载完成后执行
			window.onload = function() {
				if ($("#J_MapCompanyBox").attr("data-iswechat") == "true") {
					// 独立店铺，直接模拟跳到路线
					if ($("#J_CompanyMap").length > 0) {
						// 等待规划未响应调出面板
						new Tips("路线规划中，请稍后...");
						setTimeout(function() {
							$("#J_AppExitTipWarp").remove();
							if ($(".j_MapCompanyList").attr("data-distance") <= x_distance) {
								// 执行点击事件
								// $(".j_MapCompanyLocation").trigger("click");
							}
						}, 2500);
						
						// 自动获取路线(取消自动获取)
						//setTimeout(companyMapWay, 3000);
						//  持续执行
						setInterval(mapWay, 1000);
						
						// 显示窗口
						$("#J_MapCompanyBox").css("display", "block");
					} else {
						// 持续执行
						setInterval(mapWay, 1000);
					}
				}
			};
		}
		
		// 判断微信是否登录，否则跳转执行登录
		if (!GLOBAL.islogin && !($("#J_LoginForm").length > 0)) {
			// 不跳转登录添加例外
			var is_model_login = false;
			$.each(array_model, function(key, value) {
				var controller = value[0];
				var action = value[1];
				if (GLOBAL.Config.controller == controller && GLOBAL.Config.action == action) {
					is_model_login = true;
				}
			});
			
			if (!is_model_login) {
				var message = "检测到微信环境，即将跳转登录！";
				new Confirms(message,
					function () {
						var url = GLOBAL.Config.base + '/customer/login/';
						window.location = url;
					},
					function() {
						return false;
					}
				);
			}
		}
		
		// 微信环境中二维码提示改变
		if ($(".j_WxqrcodeTip").length > 0) {
			var data = $(".j_WxqrcodeTip").attr("data-wxtext");
			$(".j_WxqrcodeTip").text(data);
		}
	}
});
